/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.93 Revision 1.120
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.93 2010/03/12 18:27:01 betelgeuse Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.120 2011/07/08 07:40:02 djc Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
13 13
14if ! has "${EAPI:-0}" 0 1 2 3; then 14if ! has "${EAPI:-0}" 0 1 2 3; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 15 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 16fi
17 17
18_CPYTHON2_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_CPYTHON3_SUPPORTED_ABIS=(3.0 3.1 3.2) 19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.0 3.1 3.2 3.3)
20_JYTHON_SUPPORTED_ABIS=(2.5-jython) 20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
21_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]})
22
23# ================================================================================================
24# ===================================== HANDLING OF METADATA =====================================
25# ================================================================================================
26
27_PYTHON_ABI_PATTERN_REGEX="([[:alnum:]]|\.|-|\*|\[|\])+"
28
29_python_check_python_abi_matching() {
30 local pattern patterns patterns_list="0" PYTHON_ABI
31
32 while (($#)); do
33 case "$1" in
34 --patterns-list)
35 patterns_list="1"
36 ;;
37 --)
38 shift
39 break
40 ;;
41 -*)
42 die "${FUNCNAME}(): Unrecognized option '$1'"
43 ;;
44 *)
45 break
46 ;;
47 esac
48 shift
49 done
50
51 if [[ "$#" -ne 2 ]]; then
52 die "${FUNCNAME}() requires 2 arguments"
53 fi
54
55 PYTHON_ABI="$1"
56
57 if [[ "${patterns_list}" == "0" ]]; then
58 pattern="$2"
59
60 if [[ "${pattern}" == *"-cpython" ]]; then
61 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]]
62 elif [[ "${pattern}" == *"-jython" ]]; then
63 [[ "${PYTHON_ABI}" == ${pattern} ]]
64 else
65 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
66 [[ "${PYTHON_ABI}" == ${pattern} ]]
67 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
68 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]]
69 else
70 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'"
71 fi
72 fi
73 else
74 patterns="${2// /$'\n'}"
75
76 while read pattern; do
77 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
78 return 0
79 fi
80 done <<< "${patterns}"
81
82 return 1
83 fi
84}
21 85
22# @ECLASS-VARIABLE: PYTHON_DEPEND 86# @ECLASS-VARIABLE: PYTHON_DEPEND
23# @DESCRIPTION: 87# @DESCRIPTION:
24# Specification of dependency on dev-lang/python. 88# Specification of dependency on dev-lang/python.
25# Syntax: 89# Syntax:
27# version_components_group: <major_version[:[minimal_version][:maximal_version]]> 91# version_components_group: <major_version[:[minimal_version][:maximal_version]]>
28# major_version: <2|3|*> 92# major_version: <2|3|*>
29# minimal_version: <minimal_major_version.minimal_minor_version> 93# minimal_version: <minimal_major_version.minimal_minor_version>
30# maximal_version: <maximal_major_version.maximal_minor_version> 94# maximal_version: <maximal_major_version.maximal_minor_version>
31 95
32_parse_PYTHON_DEPEND() { 96_python_parse_PYTHON_DEPEND() {
33 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups 97 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups
34 98
35 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?" 99 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?"
36 version_components_groups="${PYTHON_DEPEND}" 100 version_components_groups="${PYTHON_DEPEND}"
37 101
60 fi 124 fi
61 fi 125 fi
62 126
63 if [[ "${major_version}" == "2" ]]; then 127 if [[ "${major_version}" == "2" ]]; then
64 python2="1" 128 python2="1"
65 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}") 129 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
66 python2_minimal_version="${minimal_version}" 130 python2_minimal_version="${minimal_version}"
67 python2_maximal_version="${maximal_version}" 131 python2_maximal_version="${maximal_version}"
68 elif [[ "${major_version}" == "3" ]]; then 132 elif [[ "${major_version}" == "3" ]]; then
69 python3="1" 133 python3="1"
70 python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}") 134 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
71 python3_minimal_version="${minimal_version}" 135 python3_minimal_version="${minimal_version}"
72 python3_maximal_version="${maximal_version}" 136 python3_maximal_version="${maximal_version}"
73 else 137 else
74 python_all="1" 138 python_all="1"
75 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}") 139 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
76 python_minimal_version="${minimal_version}" 140 python_minimal_version="${minimal_version}"
77 python_maximal_version="${maximal_version}" 141 python_maximal_version="${maximal_version}"
78 fi 142 fi
79 143
80 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then 144 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then
108 172
109 if [[ "${python_all}" == "1" ]]; then 173 if [[ "${python_all}" == "1" ]]; then
110 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then 174 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then
111 _PYTHON_ATOMS+=("dev-lang/python") 175 _PYTHON_ATOMS+=("dev-lang/python")
112 else 176 else
113 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}") 177 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
114 python_minimal_version="${python_minimal_version:-${python_versions[0]}}" 178 python_minimal_version="${python_minimal_version:-${python_versions[0]}}"
115 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 179 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
116 _append_accepted_versions_range 180 _append_accepted_versions_range
117 fi 181 fi
118 else 182 else
119 if [[ "${python3}" == "1" ]]; then 183 if [[ "${python3}" == "1" ]]; then
120 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then 184 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then
121 _PYTHON_ATOMS+=("=dev-lang/python-3*") 185 _PYTHON_ATOMS+=("=dev-lang/python-3*")
122 else 186 else
123 python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}") 187 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
124 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}" 188 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}"
125 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 189 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
126 _append_accepted_versions_range 190 _append_accepted_versions_range
127 fi 191 fi
128 fi 192 fi
129 if [[ "${python2}" == "1" ]]; then 193 if [[ "${python2}" == "1" ]]; then
130 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then 194 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then
131 _PYTHON_ATOMS+=("=dev-lang/python-2*") 195 _PYTHON_ATOMS+=("=dev-lang/python-2*")
132 else 196 else
133 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}") 197 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
134 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}" 198 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}"
135 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 199 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
136 _append_accepted_versions_range 200 _append_accepted_versions_range
137 fi 201 fi
138 fi 202 fi
153} 217}
154 218
155DEPEND=">=app-admin/eselect-python-20091230" 219DEPEND=">=app-admin/eselect-python-20091230"
156RDEPEND="${DEPEND}" 220RDEPEND="${DEPEND}"
157 221
158if [[ -n "${PYTHON_DEPEND}" && -n "${NEED_PYTHON}" ]]; then
159 die "PYTHON_DEPEND and NEED_PYTHON cannot be set simultaneously"
160elif [[ -n "${PYTHON_DEPEND}" ]]; then 222if [[ -n "${PYTHON_DEPEND}" ]]; then
161 _parse_PYTHON_DEPEND 223 _python_parse_PYTHON_DEPEND
162elif [[ -n "${NEED_PYTHON}" ]]; then
163 if ! has "${EAPI:-0}" 0 1 2; then
164 eerror "Use PYTHON_DEPEND instead of NEED_PYTHON."
165 die "NEED_PYTHON cannot be used in this EAPI"
166 fi
167 _PYTHON_ATOMS=(">=dev-lang/python-${NEED_PYTHON}")
168 DEPEND+="${DEPEND:+ }${_PYTHON_ATOMS[@]}"
169 RDEPEND+="${RDEPEND:+ }${_PYTHON_ATOMS[@]}"
170else 224else
171 _PYTHON_ATOMS=("dev-lang/python") 225 _PYTHON_ATOMS=("dev-lang/python")
172fi 226fi
227unset -f _python_parse_PYTHON_DEPEND
228
229if [[ -n "${NEED_PYTHON}" ]]; then
230 eerror "Use PYTHON_DEPEND variable instead of NEED_PYTHON variable."
231 die "NEED_PYTHON variable is banned"
232fi
173 233
174# @ECLASS-VARIABLE: PYTHON_USE_WITH 234# @ECLASS-VARIABLE: PYTHON_USE_WITH
175# @DESCRIPTION: 235# @DESCRIPTION:
176# Set this to a space separated list of USE flags the Python slot in use must be built with. 236# Set this to a space separated list of USE flags the Python slot in use must be built with.
177 237
182# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT 242# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT
183# @DESCRIPTION: 243# @DESCRIPTION:
184# Set this to a name of a USE flag if you need to make either PYTHON_USE_WITH or 244# Set this to a name of a USE flag if you need to make either PYTHON_USE_WITH or
185# PYTHON_USE_WITH_OR atoms conditional under a USE flag. 245# PYTHON_USE_WITH_OR atoms conditional under a USE flag.
186 246
187# @FUNCTION: python_pkg_setup
188# @DESCRIPTION:
189# Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags
190# are respected. Only exported if one of those variables is set.
191if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then 247if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then
192 python_pkg_setup() {
193 # Check if phase is pkg_setup().
194 [[ "${EBUILD_PHASE}" != "setup" ]] && die "${FUNCNAME}() can be used only in pkg_setup() phase"
195
196 python_pkg_setup_fail() {
197 eerror "${1}"
198 die "${1}"
199 }
200
201 [[ ${PYTHON_USE_WITH_OPT} ]] && use !${PYTHON_USE_WITH_OPT} && return
202
203 python_pkg_setup_check_USE_flags() {
204 local pyatom use
205 pyatom="$(python_get_implementational_package)"
206
207 for use in ${PYTHON_USE_WITH}; do
208 if ! has_version "${pyatom}[${use}]"; then
209 python_pkg_setup_fail "Please rebuild ${pyatom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
210 fi
211 done
212
213 for use in ${PYTHON_USE_WITH_OR}; do
214 if has_version "${pyatom}[${use}]"; then
215 return
216 fi
217 done
218
219 if [[ ${PYTHON_USE_WITH_OR} ]]; then
220 python_pkg_setup_fail "Please rebuild ${pyatom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
221 fi
222 }
223
224 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
225 python_execute_function -q python_pkg_setup_check_USE_flags
226 else
227 python_pkg_setup_check_USE_flags
228 fi
229
230 unset -f python_pkg_setup_check_USE_flags python_pkg_setup_fail
231 }
232
233 EXPORT_FUNCTIONS pkg_setup
234
235 _PYTHON_USE_WITH_ATOMS_ARRAY=() 248 _PYTHON_USE_WITH_ATOMS_ARRAY=()
236 if [[ -n "${PYTHON_USE_WITH}" ]]; then 249 if [[ -n "${PYTHON_USE_WITH}" ]]; then
237 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do 250 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
238 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]") 251 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${PYTHON_USE_WITH// /,}]")
239 done 252 done
240 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then 253 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then
241 for _USE_flag in ${PYTHON_USE_WITH_OR}; do 254 for _USE_flag in ${PYTHON_USE_WITH_OR}; do
242 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do 255 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
243 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${_USE_flag}]") 256 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${_USE_flag}]")
259fi 272fi
260 273
261unset _PYTHON_ATOMS 274unset _PYTHON_ATOMS
262 275
263# ================================================================================================ 276# ================================================================================================
264# ======== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE VERSIONS OF PYTHON ======== 277# =================================== MISCELLANEOUS FUNCTIONS ====================================
265# ================================================================================================ 278# ================================================================================================
266 279
280_python_implementation() {
281 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
282 return 0
283 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
284 return 0
285 else
286 return 1
287 fi
288}
289
290_python_package_supporting_installation_for_multiple_python_abis() {
291 if [[ "${EBUILD_PHASE}" == "depend" ]]; then
292 die "${FUNCNAME}() cannot be used in global scope"
293 fi
294
295 if has "${EAPI:-0}" 0 1 2 3 4; then
296 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
297 return 0
298 else
299 return 1
300 fi
301 else
302 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
303 fi
304}
305
306_python_abi-specific_local_scope() {
307 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
308}
309
310_python_initialize_prefix_variables() {
311 if has "${EAPI:-0}" 0 1 2; then
312 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
313 EROOT="${ROOT%/}${EPREFIX}/"
314 fi
315 if [[ -n "${D}" && -z "${ED}" ]]; then
316 ED="${D%/}${EPREFIX}/"
317 fi
318 fi
319}
320
321unset PYTHON_SANITY_CHECKS_EXECUTED PYTHON_SKIP_SANITY_CHECKS
322
323_python_initial_sanity_checks() {
324 if [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
325 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
326 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
327 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
328 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
329 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
330 fi
331 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
332 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
333 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
334 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
335 fi
336 fi
337}
338
339_python_final_sanity_checks() {
340 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
341 local PYTHON_ABI="${PYTHON_ABI}"
342 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
343 # Ensure that appropriate version of Python is installed.
344 if ! has_version "$(python_get_implementational_package)"; then
345 die "$(python_get_implementational_package) is not installed"
346 fi
347
348 # Ensure that EPYTHON variable is respected.
349 if [[ "$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" != "${PYTHON_ABI}" ]]; then
350 eerror "Path to 'python': '$(type -p python)'"
351 eerror "ABI: '${ABI}'"
352 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
353 eerror "EPYTHON: '$(PYTHON)'"
354 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
355 eerror "Locally active version of Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
356 die "'python' does not respect EPYTHON variable"
357 fi
358 done
359 fi
360 PYTHON_SANITY_CHECKS_EXECUTED="1"
361}
362
363# @ECLASS-VARIABLE: PYTHON_COLORS
364# @DESCRIPTION:
365# User-configurable colored output.
366PYTHON_COLORS="${PYTHON_COLORS:-0}"
367
368_python_set_color_variables() {
369 if [[ "${PYTHON_COLORS}" != "0" && "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
370 _BOLD=$'\e[1m'
371 _RED=$'\e[1;31m'
372 _GREEN=$'\e[1;32m'
373 _BLUE=$'\e[1;34m'
374 _CYAN=$'\e[1;36m'
375 _NORMAL=$'\e[0m'
376 else
377 _BOLD=
378 _RED=
379 _GREEN=
380 _BLUE=
381 _CYAN=
382 _NORMAL=
383 fi
384}
385
386unset PYTHON_PKG_SETUP_EXECUTED
387
388_python_check_python_pkg_setup_execution() {
389 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
390
391 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
392 die "python_pkg_setup() not called"
393 fi
394}
395
396# @FUNCTION: python_pkg_setup
397# @DESCRIPTION:
398# Perform sanity checks and initialize environment.
399#
400# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable
401# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4.
402python_pkg_setup() {
403 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
404 die "${FUNCNAME}() can be used only in pkg_setup() phase"
405 fi
406
407 if [[ "$#" -ne 0 ]]; then
408 die "${FUNCNAME}() does not accept arguments"
409 fi
410
411 export JYTHON_SYSTEM_CACHEDIR="1"
412 addwrite "${EPREFIX}/var/cache/jython"
413
414 if _python_package_supporting_installation_for_multiple_python_abis; then
415 _python_calculate_PYTHON_ABIS
416 export EPYTHON="$(PYTHON -f)"
417 else
418 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
419 fi
420
421 if ! has "${EAPI:-0}" 0 1 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; then
422 if [[ "${PYTHON_USE_WITH_OPT}" ]]; then
423 if [[ "${PYTHON_USE_WITH_OPT}" == !* ]]; then
424 use ${PYTHON_USE_WITH_OPT#!} && return
425 else
426 use !${PYTHON_USE_WITH_OPT} && return
427 fi
428 fi
429
430 python_pkg_setup_check_USE_flags() {
431 local python_atom USE_flag
432 python_atom="$(python_get_implementational_package)"
433
434 for USE_flag in ${PYTHON_USE_WITH}; do
435 if ! has_version "${python_atom}[${USE_flag}]"; then
436 eerror "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
437 die "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
438 fi
439 done
440
441 for USE_flag in ${PYTHON_USE_WITH_OR}; do
442 if has_version "${python_atom}[${USE_flag}]"; then
443 return
444 fi
445 done
446
447 if [[ ${PYTHON_USE_WITH_OR} ]]; then
448 eerror "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
449 die "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
450 fi
451 }
452
453 if _python_package_supporting_installation_for_multiple_python_abis; then
454 PYTHON_SKIP_SANITY_CHECKS="1" python_execute_function -q python_pkg_setup_check_USE_flags
455 else
456 python_pkg_setup_check_USE_flags
457 fi
458
459 unset -f python_pkg_setup_check_USE_flags
460 fi
461
462 PYTHON_PKG_SETUP_EXECUTED="1"
463}
464
465if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
466 EXPORT_FUNCTIONS pkg_setup
467fi
468
469_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|python)'
470
471# @FUNCTION: python_convert_shebangs
472# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
473# @DESCRIPTION:
474# Convert shebangs in specified files. Directories can be specified only with --recursive option.
475python_convert_shebangs() {
476 _python_check_python_pkg_setup_execution
477
478 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0"
479
480 while (($#)); do
481 case "$1" in
482 -r|--recursive)
483 recursive="1"
484 ;;
485 -q|--quiet)
486 quiet="1"
487 ;;
488 -x|--only-executables)
489 only_executables="1"
490 ;;
491 --)
492 shift
493 break
494 ;;
495 -*)
496 die "${FUNCNAME}(): Unrecognized option '$1'"
497 ;;
498 *)
499 break
500 ;;
501 esac
502 shift
503 done
504
505 if [[ "$#" -eq 0 ]]; then
506 die "${FUNCNAME}(): Missing Python version and files or directories"
507 elif [[ "$#" -eq 1 ]]; then
508 die "${FUNCNAME}(): Missing files or directories"
509 fi
510
511 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
512 python_interpreter="$(PYTHON "$1")"
513 else
514 python_interpreter="python$1"
515 fi
516 shift
517
518 for argument in "$@"; do
519 if [[ ! -e "${argument}" ]]; then
520 die "${FUNCNAME}(): '${argument}' does not exist"
521 elif [[ -f "${argument}" ]]; then
522 files+=("${argument}")
523 elif [[ -d "${argument}" ]]; then
524 if [[ "${recursive}" == "1" ]]; then
525 while read -d $'\0' -r file; do
526 files+=("${file}")
527 done < <(find "${argument}" $([[ "${only_executables}" == "1" ]] && echo -perm /111) -type f -print0)
528 else
529 die "${FUNCNAME}(): '${argument}' is not a regular file"
530 fi
531 else
532 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory"
533 fi
534 done
535
536 for file in "${files[@]}"; do
537 file="${file#./}"
538 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
539
540 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
541 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
542
543 if [[ "${quiet}" == "0" ]]; then
544 einfo "Converting shebang in '${file}'"
545 fi
546
547 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
548 fi
549 done
550}
551
552# @FUNCTION: python_clean_installation_image
553# @USAGE: [-q|--quiet]
554# @DESCRIPTION:
555# Delete needless files in installation image.
556#
557# This function can be used only in src_install() phase.
558python_clean_installation_image() {
559 if [[ "${EBUILD_PHASE}" != "install" ]]; then
560 die "${FUNCNAME}() can be used only in src_install() phase"
561 fi
562
563 _python_check_python_pkg_setup_execution
564 _python_initialize_prefix_variables
565
566 local file files=() quiet="0"
567
568 while (($#)); do
569 case "$1" in
570 -q|--quiet)
571 quiet="1"
572 ;;
573 -*)
574 die "${FUNCNAME}(): Unrecognized option '$1'"
575 ;;
576 *)
577 die "${FUNCNAME}(): Invalid usage"
578 ;;
579 esac
580 shift
581 done
582
583 while read -d $'\0' -r file; do
584 files+=("${file}")
585 done < <(find "${ED}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -type f -print0)
586
587 if [[ "${#files[@]}" -gt 0 ]]; then
588 if [[ "${quiet}" == "0" ]]; then
589 ewarn "Deleting byte-compiled Python modules needlessly generated by build system:"
590 fi
591 for file in "${files[@]}"; do
592 if [[ "${quiet}" == "0" ]]; then
593 ewarn " ${file}"
594 fi
595 rm -f "${file}"
596
597 # Delete empty __pycache__ directories.
598 if [[ "${file%/*}" == *"/__pycache__" ]]; then
599 rmdir "${file%/*}" 2> /dev/null
600 fi
601 done
602 fi
603
604 python_clean_sitedirs() {
605 if [[ -d "${ED}$(python_get_sitedir)" ]]; then
606 find "${ED}$(python_get_sitedir)" "(" -name "*.c" -o -name "*.h" -o -name "*.la" ")" -type f -print0 | xargs -0 rm -f
607 fi
608 }
609 if _python_package_supporting_installation_for_multiple_python_abis; then
610 python_execute_function -q python_clean_sitedirs
611 else
612 python_clean_sitedirs
613 fi
614
615 unset -f python_clean_sitedirs
616}
617
618# ================================================================================================
619# =========== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ============
620# ================================================================================================
621
267# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS 622# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS
268# @DESCRIPTION: 623# @DESCRIPTION:
269# Set this in EAPI <= 4 to indicate that current package supports installation for 624# Set this in EAPI <= 4 to indicate that current package supports installation for
270# multiple versions of Python. 625# multiple Python ABIs.
626
627# @ECLASS-VARIABLE: PYTHON_TESTS_RESTRICTED_ABIS
628# @DESCRIPTION:
629# Space-separated list of Python ABI patterns. Testing in Python ABIs matching any Python ABI
630# patterns specified in this list is skipped.
271 631
272# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS 632# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS
273# @DESCRIPTION: 633# @DESCRIPTION:
274# Set this to export phase functions for the following ebuild phases: 634# Set this to export phase functions for the following ebuild phases:
275# src_prepare, src_configure, src_compile, src_test, src_install. 635# src_prepare(), src_configure(), src_compile(), src_test(), src_install().
276if ! has "${EAPI:-0}" 0 1 && [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 636if ! has "${EAPI:-0}" 0 1; then
277 python_src_prepare() { 637 python_src_prepare() {
638 if [[ "${EBUILD_PHASE}" != "prepare" ]]; then
639 die "${FUNCNAME}() can be used only in src_prepare() phase"
640 fi
641
642 if ! _python_package_supporting_installation_for_multiple_python_abis; then
643 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
644 fi
645
646 _python_check_python_pkg_setup_execution
647
648 if [[ "$#" -ne 0 ]]; then
649 die "${FUNCNAME}() does not accept arguments"
650 fi
651
278 python_copy_sources 652 python_copy_sources
279 } 653 }
280 654
281 for python_default_function in src_configure src_compile src_test src_install; do 655 for python_default_function in src_configure src_compile src_test; do
282 eval "python_${python_default_function}() { python_execute_function -d -s; }" 656 eval "python_${python_default_function}() {
657 if [[ \"\${EBUILD_PHASE}\" != \"${python_default_function#src_}\" ]]; then
658 die \"\${FUNCNAME}() can be used only in ${python_default_function}() phase\"
659 fi
660
661 if ! _python_package_supporting_installation_for_multiple_python_abis; then
662 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\"
663 fi
664
665 _python_check_python_pkg_setup_execution
666
667 python_execute_function -d -s -- \"\$@\"
668 }"
283 done 669 done
284 unset python_default_function 670 unset python_default_function
671
672 python_src_install() {
673 if [[ "${EBUILD_PHASE}" != "install" ]]; then
674 die "${FUNCNAME}() can be used only in src_install() phase"
675 fi
676
677 if ! _python_package_supporting_installation_for_multiple_python_abis; then
678 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
679 fi
680
681 _python_check_python_pkg_setup_execution
682
683 if has "${EAPI:-0}" 0 1 2 3; then
684 python_execute_function -d -s -- "$@"
685 else
686 python_installation() {
687 emake DESTDIR="${T}/images/${PYTHON_ABI}" install "$@"
688 }
689 python_execute_function -s python_installation "$@"
690 unset python_installation
691
692 python_merge_intermediate_installation_images "${T}/images"
693 fi
694 }
285 695
286 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then 696 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
287 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install 697 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
288 fi 698 fi
289fi 699fi
290 700
701if has "${EAPI:-0}" 0 1 2 3 4; then
291unset PYTHON_ABIS 702 unset PYTHON_ABIS
703fi
292 704
293# @FUNCTION: validate_PYTHON_ABIS 705_python_calculate_PYTHON_ABIS() {
294# @DESCRIPTION: 706 if ! _python_package_supporting_installation_for_multiple_python_abis; then
295# Ensure that PYTHON_ABIS variable has valid value. 707 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
296# This function usually should not be directly called in ebuilds.
297validate_PYTHON_ABIS() {
298 # Ensure that some functions cannot be accidentally successfully used in EAPI <= 4 without setting SUPPORT_PYTHON_ABIS variable.
299 if has "${EAPI:-0}" 0 1 2 3 4 && [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then
300 die "${FUNCNAME}() cannot be used in this EAPI without setting SUPPORT_PYTHON_ABIS variable"
301 fi 708 fi
302 709
303 _python_initial_sanity_checks 710 _python_initial_sanity_checks
304 711
305 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 5.
306 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then 712 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
307 local PYTHON_ABI restricted_ABI support_ABI supported_PYTHON_ABIS= 713 local PYTHON_ABI
308 PYTHON_ABI_SUPPORTED_VALUES="${_CPYTHON2_SUPPORTED_ABIS[@]} ${_CPYTHON3_SUPPORTED_ABIS[@]} ${_JYTHON_SUPPORTED_ABIS[@]}"
309 714
310 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then 715 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
311 local python2_enabled="0" python3_enabled="0" 716 local cpython_enabled="0"
312 717
313 if [[ -z "${USE_PYTHON}" ]]; then 718 if [[ -z "${USE_PYTHON}" ]]; then
314 die "USE_PYTHON variable is empty" 719 die "USE_PYTHON variable is empty"
315 fi 720 fi
316 721
317 for PYTHON_ABI in ${USE_PYTHON}; do 722 for PYTHON_ABI in ${USE_PYTHON}; do
318 if ! has "${PYTHON_ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then 723 if ! has "${PYTHON_ABI}" "${_PYTHON_GLOBALLY_SUPPORTED_ABIS[@]}"; then
319 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'" 724 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
320 fi 725 fi
321 726
322 if has "${PYTHON_ABI}" "${_CPYTHON2_SUPPORTED_ABIS[@]}"; then 727 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then
323 python2_enabled="1" 728 cpython_enabled="1"
729 fi
730
731 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
732 export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
733 fi
734 done
735
736 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
737 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
324 fi 738 fi
325 if has "${PYTHON_ABI}" "${_CPYTHON3_SUPPORTED_ABIS[@]}"; then 739
326 python3_enabled="1" 740 if [[ "${cpython_enabled}" == "0" ]]; then
741 die "USE_PYTHON variable does not enable any CPython ABI"
327 fi 742 fi
743 else
744 local python_version python2_version python3_version support_python_major_version
328 745
329 support_ABI="1" 746 if ! has_version "dev-lang/python"; then
330 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 747 die "${FUNCNAME}(): 'dev-lang/python' is not installed"
331 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 748 fi
332 support_ABI="0" 749
750 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
751
752 if has_version "=dev-lang/python-2*"; then
753 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
754 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
755 fi
756
757 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
758
759 support_python_major_version="0"
760 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
761 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
762 support_python_major_version="1"
333 break 763 break
334 fi 764 fi
335 done 765 done
336 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
337 done
338
339 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
340 die "USE_PYTHON variable does not enable any version of Python supported by ${CATEGORY}/${PF}"
341 fi
342
343 if [[ "${python2_enabled}" == "0" ]]; then
344 ewarn "USE_PYTHON variable does not enable any version of Python 2. This configuration is unsupported."
345 fi
346 if [[ "${python3_enabled}" == "0" ]]; then
347 ewarn "USE_PYTHON variable does not enable any version of Python 3. This configuration is unsupported."
348 fi
349 if [[ "${python2_enabled}" == "0" && "${python3_enabled}" == "0" ]]; then
350 die "USE_PYTHON variable does not enable any version of CPython"
351 fi
352 else
353 local python_version python2_version= python3_version= support_python_major_version
354
355 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
356
357 if has_version "=dev-lang/python-2*"; then
358 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
359 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
360 fi
361
362 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
363
364 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do
365 support_python_major_version="1"
366 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
367 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
368 support_python_major_version="0"
369 fi
370 done
371 [[ "${support_python_major_version}" == "1" ]] && break
372 done
373 if [[ "${support_python_major_version}" == "1" ]]; then 766 if [[ "${support_python_major_version}" == "1" ]]; then
374 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 767 if _python_check_python_abi_matching --patterns-list "${python2_version}" "${RESTRICT_PYTHON_ABIS}"; then
375 if [[ "${python2_version}" == ${restricted_ABI} ]]; then
376 die "Active version of Python 2 is not supported by ${CATEGORY}/${PF}" 768 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}"
377 fi 769 fi
378 done
379 else 770 else
380 python2_version="" 771 python2_version=""
381 fi 772 fi
382 fi 773 fi
383 774
386 die "'${EPREFIX}/usr/bin/python3' is not valid symlink" 777 die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
387 fi 778 fi
388 779
389 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 780 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
390 781
782 support_python_major_version="0"
391 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do 783 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
784 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
392 support_python_major_version="1" 785 support_python_major_version="1"
393 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 786 break
394 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
395 support_python_major_version="0"
396 fi 787 fi
397 done
398 [[ "${support_python_major_version}" == "1" ]] && break
399 done 788 done
400 if [[ "${support_python_major_version}" == "1" ]]; then 789 if [[ "${support_python_major_version}" == "1" ]]; then
401 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 790 if _python_check_python_abi_matching --patterns-list "${python3_version}" "${RESTRICT_PYTHON_ABIS}"; then
402 if [[ "${python3_version}" == ${restricted_ABI} ]]; then
403 die "Active version of Python 3 is not supported by ${CATEGORY}/${PF}" 791 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
404 fi 792 fi
405 done
406 else 793 else
407 python3_version="" 794 python3_version=""
408 fi 795 fi
409 fi 796 fi
410 797
426 fi 813 fi
427 814
428 _python_final_sanity_checks 815 _python_final_sanity_checks
429} 816}
430 817
818_python_prepare_flags() {
819 local array=() deleted_flag element flags new_value old_flag old_value operator pattern prefix variable
820
821 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
822 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\""
823 for prefix in PYTHON_USER_ PYTHON_; do
824 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then
825 eval "array=(\"\${${prefix}${variable}[@]}\")"
826 for element in "${array[@]}"; do
827 if [[ "${element}" =~ ^${_PYTHON_ABI_PATTERN_REGEX}\ (\+|-)\ .+ ]]; then
828 pattern="${element%% *}"
829 element="${element#* }"
830 operator="${element%% *}"
831 flags="${element#* }"
832 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
833 if [[ "${operator}" == "+" ]]; then
834 eval "export ${variable}+=\"\${variable:+ }${flags}\""
835 elif [[ "${operator}" == "-" ]]; then
836 flags="${flags// /$'\n'}"
837 old_value="${!variable// /$'\n'}"
838 new_value=""
839 while read old_flag; do
840 while read deleted_flag; do
841 if [[ "${old_flag}" == ${deleted_flag} ]]; then
842 continue 2
843 fi
844 done <<< "${flags}"
845 new_value+="${new_value:+ }${old_flag}"
846 done <<< "${old_value}"
847 eval "export ${variable}=\"\${new_value}\""
848 fi
849 fi
850 else
851 die "Element '${element}' of ${prefix}${variable} array has invalid syntax"
852 fi
853 done
854 elif [[ -n "$(declare -p ${prefix}${variable} 2> /dev/null)" ]]; then
855 die "${prefix}${variable} should be indexed array"
856 fi
857 done
858 done
859}
860
861_python_restore_flags() {
862 local variable
863
864 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
865 eval "${variable}=\"\${_PYTHON_SAVED_${variable}}\""
866 unset _PYTHON_SAVED_${variable}
867 done
868}
869
431# @FUNCTION: python_execute_function 870# @FUNCTION: python_execute_function
432# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments] 871# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
433# @DESCRIPTION: 872# @DESCRIPTION:
434# Execute specified function for each value of PYTHON_ABIS, optionally passing additional 873# Execute specified function for each value of PYTHON_ABIS, optionally passing additional
435# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables. 874# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables.
436python_execute_function() { 875python_execute_function() {
876 if ! _python_package_supporting_installation_for_multiple_python_abis; then
877 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
878 fi
879
880 _python_check_python_pkg_setup_execution
437 _python_set_color_variables 881 _python_set_color_variables
438 882
439 local action action_message action_message_template= default_function="0" failure_message failure_message_template= final_ABI="0" function i iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" separate_build_dirs="0" source_dir= 883 local action action_message action_message_template default_function="0" failure_message failure_message_template final_ABI="0" function iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" return_code separate_build_dirs="0" source_dir
440 884
441 while (($#)); do 885 while (($#)); do
442 case "$1" in 886 case "$1" in
443 --action-message) 887 --action-message)
444 action_message_template="$2" 888 action_message_template="$2"
494 938
495 if [[ -z "$(type -t "${function}")" ]]; then 939 if [[ -z "$(type -t "${function}")" ]]; then
496 die "${FUNCNAME}(): '${function}' function is not defined" 940 die "${FUNCNAME}(): '${function}' function is not defined"
497 fi 941 fi
498 else 942 else
499 if [[ "$#" -ne 0 ]]; then
500 die "${FUNCNAME}(): '--default-function' option and function name cannot be specified simultaneously"
501 fi
502 if has "${EAPI:-0}" 0 1; then 943 if has "${EAPI:-0}" 0 1; then
503 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI" 944 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI"
504 fi 945 fi
505 946
506 if [[ "${EBUILD_PHASE}" == "configure" ]]; then 947 if [[ "${EBUILD_PHASE}" == "configure" ]]; then
507 if has "${EAPI}" 2 3; then 948 if has "${EAPI}" 2 3; then
508 python_default_function() { 949 python_default_function() {
509 econf 950 econf "$@"
510 } 951 }
511 else 952 else
512 python_default_function() { 953 python_default_function() {
513 nonfatal econf 954 nonfatal econf "$@"
514 } 955 }
515 fi 956 fi
516 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then 957 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then
517 python_default_function() { 958 python_default_function() {
518 emake 959 emake "$@"
519 } 960 }
520 elif [[ "${EBUILD_PHASE}" == "test" ]]; then 961 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
521 python_default_function() { 962 python_default_function() {
522 if emake -j1 -n check &> /dev/null; then 963 if emake -j1 -n check &> /dev/null; then
523 emake -j1 check 964 emake -j1 check "$@"
524 elif emake -j1 -n test &> /dev/null; then 965 elif emake -j1 -n test &> /dev/null; then
525 emake -j1 test 966 emake -j1 test "$@"
526 fi 967 fi
527 } 968 }
528 elif [[ "${EBUILD_PHASE}" == "install" ]]; then 969 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
529 python_default_function() { 970 python_default_function() {
530 emake DESTDIR="${D}" install 971 emake DESTDIR="${D}" install "$@"
531 } 972 }
532 else 973 else
533 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase" 974 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase"
534 fi 975 fi
535 function="python_default_function" 976 function="python_default_function"
536 fi 977 fi
537 978
538 for ((i = 1; i < "${#FUNCNAME[@]}"; i++)); do 979 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function().
539 if [[ "${FUNCNAME[${i}]}" == "${FUNCNAME}" ]]; then 980 if _python_abi-specific_local_scope; then
540 die "${FUNCNAME}(): Invalid call stack" 981 die "${FUNCNAME}(): Invalid call stack"
541 fi 982 fi
542 done
543 983
544 if [[ "${quiet}" == "0" ]]; then 984 if [[ "${quiet}" == "0" ]]; then
545 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up" 985 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up"
546 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking" 986 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking"
547 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation" 987 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation"
553 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation" 993 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation"
554 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation" 994 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation"
555 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation" 995 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation"
556 fi 996 fi
557 997
558 validate_PYTHON_ABIS 998 _python_calculate_PYTHON_ABIS
559 if [[ "${final_ABI}" == "1" ]]; then 999 if [[ "${final_ABI}" == "1" ]]; then
560 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)" 1000 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)"
561 else 1001 else
562 iterated_PYTHON_ABIS="${PYTHON_ABIS}" 1002 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
563 fi 1003 fi
564 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 1004 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1005 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then
1006 if [[ "${quiet}" == "0" ]]; then
1007 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version) skipped${_NORMAL}"
1008 fi
1009 continue
1010 fi
1011
1012 _python_prepare_flags
1013
565 if [[ "${quiet}" == "0" ]]; then 1014 if [[ "${quiet}" == "0" ]]; then
566 if [[ -n "${action_message_template}" ]]; then 1015 if [[ -n "${action_message_template}" ]]; then
567 action_message="$(eval echo -n "${action_message_template}")" 1016 eval "action_message=\"${action_message_template}\""
568 else 1017 else
569 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..." 1018 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..."
570 fi 1019 fi
571 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}" 1020 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
572 fi 1021 fi
590 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@" 1039 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@"
591 else 1040 else
592 EPYTHON="$(PYTHON)" "${function}" "$@" 1041 EPYTHON="$(PYTHON)" "${function}" "$@"
593 fi 1042 fi
594 1043
595 if [[ "$?" != "0" ]]; then 1044 return_code="$?"
1045
1046 _python_restore_flags
1047
1048 if [[ "${return_code}" -ne 0 ]]; then
596 if [[ -n "${failure_message_template}" ]]; then 1049 if [[ -n "${failure_message_template}" ]]; then
597 failure_message="$(eval echo -n "${failure_message_template}")" 1050 eval "failure_message=\"${failure_message_template}\""
598 else 1051 else
599 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function" 1052 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function"
600 fi 1053 fi
601 1054
602 if [[ "${nonfatal}" == "1" ]]; then 1055 if [[ "${nonfatal}" == "1" ]]; then
603 if [[ "${quiet}" == "0" ]]; then 1056 if [[ "${quiet}" == "0" ]]; then
604 ewarn "${_RED}${failure_message}${_NORMAL}" 1057 ewarn "${failure_message}"
605 fi 1058 fi
606 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then 1059 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
607 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then 1060 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then
608 local enabled_PYTHON_ABIS= other_PYTHON_ABI 1061 local enabled_PYTHON_ABIS= other_PYTHON_ABI
609 for other_PYTHON_ABI in ${PYTHON_ABIS}; do 1062 for other_PYTHON_ABI in ${PYTHON_ABIS}; do
610 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}" 1063 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}"
611 done 1064 done
612 export PYTHON_ABIS="${enabled_PYTHON_ABIS}" 1065 export PYTHON_ABIS="${enabled_PYTHON_ABIS}"
613 fi 1066 fi
614 if [[ "${quiet}" == "0" ]]; then 1067 if [[ "${quiet}" == "0" ]]; then
615 ewarn "${_RED}${failure_message}${_NORMAL}" 1068 ewarn "${failure_message}"
616 fi 1069 fi
617 if [[ -z "${PYTHON_ABIS}" ]]; then 1070 if [[ -z "${PYTHON_ABIS}" ]]; then
618 die "${function}() function failed with all enabled versions of Python" 1071 die "${function}() function failed with all enabled Python ABIs"
619 fi 1072 fi
620 else 1073 else
621 die "${failure_message}" 1074 die "${failure_message}"
622 fi 1075 fi
623 fi 1076 fi
657# @FUNCTION: python_copy_sources 1110# @FUNCTION: python_copy_sources
658# @USAGE: <directory="${S}"> [directory] 1111# @USAGE: <directory="${S}"> [directory]
659# @DESCRIPTION: 1112# @DESCRIPTION:
660# Copy unpacked sources of current package to separate build directory for each Python ABI. 1113# Copy unpacked sources of current package to separate build directory for each Python ABI.
661python_copy_sources() { 1114python_copy_sources() {
1115 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1116 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1117 fi
1118
1119 _python_check_python_pkg_setup_execution
1120
662 local dir dirs=() PYTHON_ABI 1121 local dir dirs=() PYTHON_ABI
663 1122
664 if [[ "$#" -eq 0 ]]; then 1123 if [[ "$#" -eq 0 ]]; then
665 if [[ "${WORKDIR}" == "${S}" ]]; then 1124 if [[ "${WORKDIR}" == "${S}" ]]; then
666 die "${FUNCNAME}() cannot be used" 1125 die "${FUNCNAME}() cannot be used with current value of S variable"
667 fi 1126 fi
668 dirs=("${S}") 1127 dirs=("${S%/}")
669 else 1128 else
670 dirs=("$@") 1129 dirs=("$@")
671 fi 1130 fi
672 1131
673 validate_PYTHON_ABIS 1132 _python_calculate_PYTHON_ABIS
674 for PYTHON_ABI in ${PYTHON_ABIS}; do 1133 for PYTHON_ABI in ${PYTHON_ABIS}; do
675 for dir in "${dirs[@]}"; do 1134 for dir in "${dirs[@]}"; do
676 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed" 1135 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
677 done 1136 done
678 done 1137 done
679} 1138}
680 1139
681# @FUNCTION: python_set_build_dir_symlink
682# @USAGE: <directory="build">
683# @DESCRIPTION:
684# Create build directory symlink.
685python_set_build_dir_symlink() {
686 local dir="$1"
687
688 [[ -z "${PYTHON_ABI}" ]] && die "PYTHON_ABI variable not set"
689 [[ -z "${dir}" ]] && dir="build"
690
691 # Do not delete preexistent directories.
692 rm -f "${dir}" || die "Deletion of '${dir}' failed"
693 ln -s "${dir}-${PYTHON_ABI}" "${dir}" || die "Creation of '${dir}' directory symlink failed"
694}
695
696# @FUNCTION: python_generate_wrapper_scripts 1140# @FUNCTION: python_generate_wrapper_scripts
697# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files] 1141# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files]
698# @DESCRIPTION: 1142# @DESCRIPTION:
699# Generate wrapper scripts. Existing files are overwritten only with --force option. 1143# Generate wrapper scripts. Existing files are overwritten only with --force option.
700# If --respect-EPYTHON option is specified, then generated wrapper scripts will 1144# If --respect-EPYTHON option is specified, then generated wrapper scripts will
701# respect EPYTHON variable at run time. 1145# respect EPYTHON variable at run time.
1146#
1147# This function can be used only in src_install() phase.
702python_generate_wrapper_scripts() { 1148python_generate_wrapper_scripts() {
1149 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1150 die "${FUNCNAME}() can be used only in src_install() phase"
1151 fi
1152
1153 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1154 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1155 fi
1156
1157 _python_check_python_pkg_setup_execution
703 _python_initialize_prefix_variables 1158 _python_initialize_prefix_variables
704 1159
705 local eselect_python_option file force="0" quiet="0" PYTHON_ABI python2_enabled="0" python3_enabled="0" respect_EPYTHON="0" 1160 local eselect_python_option file force="0" quiet="0" PYTHON_ABI PYTHON_ABIS_list python2_enabled="0" python3_enabled="0" respect_EPYTHON="0"
706 1161
707 while (($#)); do 1162 while (($#)); do
708 case "$1" in 1163 case "$1" in
709 -E|--respect-EPYTHON) 1164 -E|--respect-EPYTHON)
710 respect_EPYTHON="1" 1165 respect_EPYTHON="1"
731 1186
732 if [[ "$#" -eq 0 ]]; then 1187 if [[ "$#" -eq 0 ]]; then
733 die "${FUNCNAME}(): Missing arguments" 1188 die "${FUNCNAME}(): Missing arguments"
734 fi 1189 fi
735 1190
736 validate_PYTHON_ABIS 1191 _python_calculate_PYTHON_ABIS
737 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do 1192 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
738 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 1193 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
739 python2_enabled="1" 1194 python2_enabled="1"
740 fi 1195 fi
741 done 1196 done
742 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do 1197 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
743 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 1198 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
744 python3_enabled="1" 1199 python3_enabled="1"
745 fi 1200 fi
746 done 1201 done
747 1202
753 eselect_python_option="--python3" 1208 eselect_python_option="--python3"
754 else 1209 else
755 die "${FUNCNAME}(): Unsupported environment" 1210 die "${FUNCNAME}(): Unsupported environment"
756 fi 1211 fi
757 1212
1213 PYTHON_ABIS_list="$("$(PYTHON -f)" -c "print(', '.join('\"%s\"' % x for x in reversed('${PYTHON_ABIS}'.split())))")"
1214
758 for file in "$@"; do 1215 for file in "$@"; do
759 if [[ -f "${file}" && "${force}" == "0" ]]; then 1216 if [[ -f "${file}" && "${force}" == "0" ]]; then
760 die "${FUNCNAME}(): '$1' already exists" 1217 die "${FUNCNAME}(): '${file}' already exists"
761 fi 1218 fi
762 1219
763 if [[ "${quiet}" == "0" ]]; then 1220 if [[ "${quiet}" == "0" ]]; then
764 einfo "Generating '${file#${D%/}}' wrapper script" 1221 einfo "Generating '${file#${ED%/}}' wrapper script"
765 fi 1222 fi
766 1223
767 cat << EOF > "${file}" 1224 cat << EOF > "${file}"
768#!/usr/bin/env python 1225#!/usr/bin/env python
769# Gentoo '${file##*/}' wrapper script 1226# Gentoo '${file##*/}' wrapper script generated by python_generate_wrapper_scripts()
770 1227
771import os 1228import os
772import re 1229import re
773import subprocess 1230import subprocess
774import sys 1231import sys
775 1232
776EPYTHON_re = re.compile(r"^python(\d+\.\d+)$") 1233cpython_re = re.compile(r"^python(\d+\.\d+)$")
1234jython_re = re.compile(r"^jython(\d+\.\d+)$")
1235python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)")
1236python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1237
1238def get_PYTHON_ABI(EPYTHON):
1239 cpython_matched = cpython_re.match(EPYTHON)
1240 jython_matched = jython_re.match(EPYTHON)
1241 if cpython_matched is not None:
1242 PYTHON_ABI = cpython_matched.group(1)
1243 elif jython_matched is not None:
1244 PYTHON_ABI = jython_matched.group(1) + "-jython"
1245 else:
1246 PYTHON_ABI = None
1247 return PYTHON_ABI
777 1248
778EOF 1249EOF
779 if [[ "$?" != "0" ]]; then 1250 if [[ "$?" != "0" ]]; then
780 die "${FUNCNAME}(): Generation of '$1' failed" 1251 die "${FUNCNAME}(): Generation of '$1' failed"
781 fi 1252 fi
782 if [[ "${respect_EPYTHON}" == "1" ]]; then 1253 if [[ "${respect_EPYTHON}" == "1" ]]; then
783 cat << EOF >> "${file}" 1254 cat << EOF >> "${file}"
784EPYTHON = os.environ.get("EPYTHON") 1255EPYTHON = os.environ.get("EPYTHON")
785if EPYTHON: 1256if EPYTHON:
786 EPYTHON_matched = EPYTHON_re.match(EPYTHON) 1257 PYTHON_ABI = get_PYTHON_ABI(EPYTHON)
787 if EPYTHON_matched: 1258 if PYTHON_ABI is None:
788 PYTHON_ABI = EPYTHON_matched.group(1)
789 else:
790 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON) 1259 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON)
791 sys.exit(1) 1260 sys.exit(1)
792else: 1261else:
793 try: 1262 try:
794 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1263 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE)
796 raise ValueError 1265 raise ValueError
797 except (OSError, ValueError): 1266 except (OSError, ValueError):
798 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1267 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
799 sys.exit(1) 1268 sys.exit(1)
800 1269
801 eselect_output = eselect_process.stdout.read() 1270 EPYTHON = eselect_process.stdout.read()
802 if not isinstance(eselect_output, str): 1271 if not isinstance(EPYTHON, str):
803 # Python 3 1272 # Python 3
804 eselect_output = eselect_output.decode() 1273 EPYTHON = EPYTHON.decode()
1274 EPYTHON = EPYTHON.rstrip("\n")
805 1275
806 EPYTHON_matched = EPYTHON_re.match(eselect_output) 1276 PYTHON_ABI = get_PYTHON_ABI(EPYTHON)
807 if EPYTHON_matched: 1277 if PYTHON_ABI is None:
808 PYTHON_ABI = EPYTHON_matched.group(1)
809 else:
810 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s" % eselect_output) 1278 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON)
811 sys.exit(1) 1279 sys.exit(1)
1280
1281wrapper_script_path = os.path.realpath(sys.argv[0])
1282target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1283if not os.path.exists(target_executable_path):
1284 sys.stderr.write("'%s' does not exist\n" % target_executable_path)
1285 sys.exit(1)
812EOF 1286EOF
813 if [[ "$?" != "0" ]]; then 1287 if [[ "$?" != "0" ]]; then
814 die "${FUNCNAME}(): Generation of '$1' failed" 1288 die "${FUNCNAME}(): Generation of '$1' failed"
815 fi 1289 fi
816 else 1290 else
821 raise ValueError 1295 raise ValueError
822except (OSError, ValueError): 1296except (OSError, ValueError):
823 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1297 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
824 sys.exit(1) 1298 sys.exit(1)
825 1299
826eselect_output = eselect_process.stdout.read() 1300EPYTHON = eselect_process.stdout.read()
827if not isinstance(eselect_output, str): 1301if not isinstance(EPYTHON, str):
828 # Python 3 1302 # Python 3
829 eselect_output = eselect_output.decode() 1303 EPYTHON = EPYTHON.decode()
1304EPYTHON = EPYTHON.rstrip("\n")
830 1305
831EPYTHON_matched = EPYTHON_re.match(eselect_output) 1306PYTHON_ABI = get_PYTHON_ABI(EPYTHON)
832if EPYTHON_matched: 1307if PYTHON_ABI is None:
833 PYTHON_ABI = EPYTHON_matched.group(1) 1308 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON)
1309 sys.exit(1)
1310
1311wrapper_script_path = os.path.realpath(sys.argv[0])
1312for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1313 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1314 if os.path.exists(target_executable_path):
1315 break
834else: 1316else:
835 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s" % eselect_output) 1317 sys.stderr.write("No target script exists for '%s'\n" % wrapper_script_path)
836 sys.exit(1) 1318 sys.exit(1)
837EOF 1319EOF
838 if [[ "$?" != "0" ]]; then 1320 if [[ "$?" != "0" ]]; then
839 die "${FUNCNAME}(): Generation of '$1' failed" 1321 die "${FUNCNAME}(): Generation of '$1' failed"
840 fi 1322 fi
841 fi 1323 fi
842 cat << EOF >> "${file}" 1324 cat << EOF >> "${file}"
843 1325
1326target_executable = open(target_executable_path, "rb")
1327target_executable_first_line = target_executable.readline()
1328if not isinstance(target_executable_first_line, str):
1329 # Python 3
1330 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1331
1332python_shebang_matched = python_shebang_re.match(target_executable_first_line)
1333target_executable.close()
1334
1335if python_shebang_matched is not None:
1336 try:
1337 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON
1338 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1339 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1340 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1341 if python_verification_process.wait() != 0:
1342 raise ValueError
1343
1344 python_verification_output = python_verification_process.stdout.read()
1345 if not isinstance(python_verification_output, str):
1346 # Python 3
1347 python_verification_output = python_verification_output.decode()
1348
1349 if not python_verification_output_re.match(python_verification_output):
1350 raise ValueError
1351
1352 if cpython_re.match(EPYTHON) is not None:
1353 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
844os.environ["PYTHON_SCRIPT_NAME"] = sys.argv[0] 1354 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
845target_executable = "%s-%s" % (os.path.realpath(sys.argv[0]), PYTHON_ABI) 1355 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
846if not os.path.exists(target_executable):
847 sys.stderr.write("'%s' does not exist\n" % target_executable)
848 sys.exit(1)
849 1356
1357 if hasattr(os, "execv"):
1358 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv)
1359 else:
1360 sys.exit(subprocess.Popen([python_interpreter_path] + sys.argv).wait())
1361 except (KeyboardInterrupt, SystemExit):
1362 raise
1363 except:
1364 pass
1365 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1366 if variable in os.environ:
1367 del os.environ[variable]
1368
1369if hasattr(os, "execv"):
850os.execv(target_executable, sys.argv) 1370 os.execv(target_executable_path, sys.argv)
1371else:
1372 sys.exit(subprocess.Popen([target_executable_path] + sys.argv[1:]).wait())
851EOF 1373EOF
852 if [[ "$?" != "0" ]]; then 1374 if [[ "$?" != "0" ]]; then
853 die "${FUNCNAME}(): Generation of '$1' failed" 1375 die "${FUNCNAME}(): Generation of '$1' failed"
854 fi 1376 fi
855 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed" 1377 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed"
856 done 1378 done
857} 1379}
858 1380
859# ================================================================================================ 1381# @ECLASS-VARIABLE: PYTHON_VERSIONED_SCRIPTS
860# ====== FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE VERSIONS OF PYTHON ======
861# ================================================================================================
862
863# @FUNCTION: python_set_active_version
864# @USAGE: <CPython_ABI|2|3>
865# @DESCRIPTION: 1382# @DESCRIPTION:
866# Set specified version of CPython as active version of Python. 1383# Array of regular expressions of paths to versioned Python scripts.
867python_set_active_version() { 1384# Python scripts in /usr/bin and /usr/sbin are versioned by default.
868 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 1385
1386# @ECLASS-VARIABLE: PYTHON_VERSIONED_EXECUTABLES
1387# @DESCRIPTION:
1388# Array of regular expressions of paths to versioned executables (including Python scripts).
1389
1390# @ECLASS-VARIABLE: PYTHON_NONVERSIONED_EXECUTABLES
1391# @DESCRIPTION:
1392# Array of regular expressions of paths to nonversioned executables (including Python scripts).
1393
1394# @FUNCTION: python_merge_intermediate_installation_images
1395# @USAGE: [-q|--quiet] [--] <intermediate_installation_images_directory>
1396# @DESCRIPTION:
1397# Merge intermediate installation images into installation image.
1398#
1399# This function can be used only in src_install() phase.
1400python_merge_intermediate_installation_images() {
1401 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1402 die "${FUNCNAME}() can be used only in src_install() phase"
1403 fi
1404
1405 if ! _python_package_supporting_installation_for_multiple_python_abis; then
869 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple versions of Python" 1406 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
870 fi 1407 fi
1408
1409 _python_check_python_pkg_setup_execution
1410 _python_initialize_prefix_variables
1411
1412 local b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=()
1413
1414 while (($#)); do
1415 case "$1" in
1416 -q|--quiet)
1417 quiet="1"
1418 ;;
1419 --)
1420 shift
1421 break
1422 ;;
1423 -*)
1424 die "${FUNCNAME}(): Unrecognized option '$1'"
1425 ;;
1426 *)
1427 break
1428 ;;
1429 esac
1430 shift
1431 done
871 1432
872 if [[ "$#" -ne 1 ]]; then 1433 if [[ "$#" -ne 1 ]]; then
873 die "${FUNCNAME}() requires 1 argument" 1434 die "${FUNCNAME}() requires 1 argument"
874 fi 1435 fi
875 1436
1437 intermediate_installation_images_directory="$1"
1438
1439 if [[ ! -d "${intermediate_installation_images_directory}" ]]; then
1440 die "${FUNCNAME}(): Intermediate installation images directory '${intermediate_installation_images_directory}' does not exist"
1441 fi
1442
1443 _python_calculate_PYTHON_ABIS
1444 if [[ "$(PYTHON -f --ABI)" == 3.* ]]; then
1445 b="b"
1446 fi
1447
1448 while read -d $'\0' -r file; do
1449 files+=("${file}")
1450 done < <("$(PYTHON -f)" -c \
1451"import os
1452import sys
1453
1454if hasattr(sys.stdout, 'buffer'):
1455 # Python 3
1456 stdout = sys.stdout.buffer
1457else:
1458 # Python 2
1459 stdout = sys.stdout
1460
1461files_set = set()
1462
1463os.chdir(${b}'${intermediate_installation_images_directory}')
1464
1465for PYTHON_ABI in ${b}'${PYTHON_ABIS}'.split():
1466 for root, dirs, files in os.walk(PYTHON_ABI + ${b}'${EPREFIX}'):
1467 root = root[len(PYTHON_ABI + ${b}'${EPREFIX}')+1:]
1468 files_set.update(root + ${b}'/' + file for file in files)
1469
1470for file in sorted(files_set):
1471 stdout.write(file)
1472 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of files in intermediate installation images")
1473
1474 for PYTHON_ABI in ${PYTHON_ABIS}; do
1475 if [[ ! -d "${intermediate_installation_images_directory}/${PYTHON_ABI}" ]]; then
1476 die "${FUNCNAME}(): Intermediate installation image for Python ABI '${PYTHON_ABI}' does not exist"
1477 fi
1478
1479 pushd "${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}" > /dev/null || die "pushd failed"
1480
1481 for file in "${files[@]}"; do
1482 version_executable="0"
1483 for regex in "/usr/bin/.*" "/usr/sbin/.*" "${PYTHON_VERSIONED_SCRIPTS[@]}"; do
1484 if [[ "/${file}" =~ ^${regex}$ ]]; then
1485 version_executable="1"
1486 break
1487 fi
1488 done
1489 for regex in "${PYTHON_VERSIONED_EXECUTABLES[@]}"; do
1490 if [[ "/${file}" =~ ^${regex}$ ]]; then
1491 version_executable="2"
1492 break
1493 fi
1494 done
1495 if [[ "${version_executable}" != "0" ]]; then
1496 for regex in "${PYTHON_NONVERSIONED_EXECUTABLES[@]}"; do
1497 if [[ "/${file}" =~ ^${regex}$ ]]; then
1498 version_executable="0"
1499 break
1500 fi
1501 done
1502 fi
1503
1504 [[ "${version_executable}" == "0" || ! -x "${file}" ]] && continue
1505
1506 shebang="$(head -n1 "${file}")" || die "Extraction of shebang from '${file}' failed"
1507
1508 if [[ "${version_executable}" == "2" ]]; then
1509 wrapper_scripts+=("${ED}${file}")
1510 elif [[ "${version_executable}" == "1" ]]; then
1511 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then
1512 wrapper_scripts+=("${ED}${file}")
1513 else
1514 version_executable="0"
1515 fi
1516 fi
1517
1518 [[ "${version_executable}" == "0" ]] && continue
1519
1520 if [[ -e "${file}-${PYTHON_ABI}" ]]; then
1521 die "${FUNCNAME}(): '${EPREFIX}/${file}-${PYTHON_ABI}' already exists"
1522 fi
1523
1524 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
1525
1526 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then
1527 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}"
1528 fi
1529 done
1530
1531 popd > /dev/null || die "popd failed"
1532
1533 if ROOT="/" has_version sys-apps/coreutils; then
1534 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1535 else
1536 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1537 fi
1538 done
1539
1540 rm -fr "${intermediate_installation_images_directory}"
1541
1542 if [[ "${#wrapper_scripts[@]}" -ge 1 ]]; then
1543 rm -f "${T}/python_wrapper_scripts"
1544
1545 for file in "${wrapper_scripts[@]}"; do
1546 echo -n "${file}" >> "${T}/python_wrapper_scripts"
1547 echo -en "\x00" >> "${T}/python_wrapper_scripts"
1548 done
1549
1550 while read -d $'\0' -r file; do
1551 wrapper_scripts_set+=("${file}")
1552 done < <("$(PYTHON -f)" -c \
1553"import sys
1554
1555if hasattr(sys.stdout, 'buffer'):
1556 # Python 3
1557 stdout = sys.stdout.buffer
1558else:
1559 # Python 2
1560 stdout = sys.stdout
1561
1562files = set(open('${T}/python_wrapper_scripts', 'rb').read().rstrip(${b}'\x00').split(${b}'\x00'))
1563
1564for file in sorted(files):
1565 stdout.write(file)
1566 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1567
1568 python_generate_wrapper_scripts $([[ "${quiet}" == "1" ]] && echo --quiet) "${wrapper_scripts_set[@]}"
1569 fi
1570}
1571
1572# ================================================================================================
1573# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ==========
1574# ================================================================================================
1575
1576unset EPYTHON PYTHON_ABI
1577
1578# @FUNCTION: python_set_active_version
1579# @USAGE: <Python_ABI|2|3>
1580# @DESCRIPTION:
1581# Set locally active version of Python.
1582# If Python_ABI argument is specified, then version of Python corresponding to Python_ABI is used.
1583# If 2 argument is specified, then active version of CPython 2 is used.
1584# If 3 argument is specified, then active version of CPython 3 is used.
1585#
1586# This function can be used only in pkg_setup() phase.
1587python_set_active_version() {
1588 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
1589 die "${FUNCNAME}() can be used only in pkg_setup() phase"
1590 fi
1591
1592 if _python_package_supporting_installation_for_multiple_python_abis; then
1593 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1594 fi
1595
1596 if [[ "$#" -ne 1 ]]; then
1597 die "${FUNCNAME}() requires 1 argument"
1598 fi
1599
876 _python_initial_sanity_checks 1600 _python_initial_sanity_checks
877 1601
878 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1602 if [[ -z "${PYTHON_ABI}" ]]; then
879 if ! _python_implementation && ! has_version "dev-lang/python:$1"; then 1603 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
880 die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed" 1604 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
1605 # so it does not need to be exported to subprocesses.
1606 PYTHON_ABI="$1"
1607 if ! _python_implementation && ! has_version "$(python_get_implementational_package)"; then
1608 die "${FUNCNAME}(): '$(python_get_implementational_package)' is not installed"
881 fi 1609 fi
882 export EPYTHON="$(PYTHON "$1")" 1610 export EPYTHON="$(PYTHON "$1")"
883 elif [[ "$1" == "2" ]]; then 1611 elif [[ "$1" == "2" ]]; then
884 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then 1612 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then
885 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed" 1613 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed"
886 fi 1614 fi
887 export EPYTHON="$(PYTHON -2)" 1615 export EPYTHON="$(PYTHON -2)"
1616 PYTHON_ABI="${EPYTHON#python}"
1617 PYTHON_ABI="${PYTHON_ABI%%-*}"
888 elif [[ "$1" == "3" ]]; then 1618 elif [[ "$1" == "3" ]]; then
889 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then 1619 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then
890 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed" 1620 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed"
891 fi 1621 fi
892 export EPYTHON="$(PYTHON -3)" 1622 export EPYTHON="$(PYTHON -3)"
1623 PYTHON_ABI="${EPYTHON#python}"
1624 PYTHON_ABI="${PYTHON_ABI%%-*}"
893 else 1625 else
894 die "${FUNCNAME}(): Unrecognized argument '$1'" 1626 die "${FUNCNAME}(): Unrecognized argument '$1'"
895 fi 1627 fi
896 1628 fi
897 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
898 # so it does not need to be exported to subprocesses.
899 PYTHON_ABI="${EPYTHON#python}"
900 PYTHON_ABI="${PYTHON_ABI%%-*}"
901 1629
902 _python_final_sanity_checks 1630 _python_final_sanity_checks
903 1631
904 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 1632 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
905 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 1633 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
907 1635
908# @FUNCTION: python_need_rebuild 1636# @FUNCTION: python_need_rebuild
909# @DESCRIPTION: Mark current package for rebuilding by python-updater after 1637# @DESCRIPTION: Mark current package for rebuilding by python-updater after
910# switching of active version of Python. 1638# switching of active version of Python.
911python_need_rebuild() { 1639python_need_rebuild() {
912 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 1640 if _python_package_supporting_installation_for_multiple_python_abis; then
913 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple versions of Python" 1641 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1642 fi
1643
1644 _python_check_python_pkg_setup_execution
1645
1646 if [[ "$#" -ne 0 ]]; then
1647 die "${FUNCNAME}() does not accept arguments"
914 fi 1648 fi
915 1649
916 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)" 1650 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)"
917} 1651}
918 1652
925sys.stdout.write(".".join(str(x) for x in sys.version_info[:2])) 1659sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
926if platform.system()[:4] == "Java": 1660if platform.system()[:4] == "Java":
927 sys.stdout.write("-jython")' 1661 sys.stdout.write("-jython")'
928 1662
929_python_get_implementation() { 1663_python_get_implementation() {
1664 local ignore_invalid="0"
1665
1666 while (($#)); do
1667 case "$1" in
1668 --ignore-invalid)
1669 ignore_invalid="1"
1670 ;;
1671 --)
1672 shift
1673 break
1674 ;;
1675 -*)
1676 die "${FUNCNAME}(): Unrecognized option '$1'"
1677 ;;
1678 *)
1679 break
1680 ;;
1681 esac
1682 shift
1683 done
1684
930 if [[ "$#" -ne 1 ]]; then 1685 if [[ "$#" -ne 1 ]]; then
931 die "${FUNCNAME}() requires 1 argument" 1686 die "${FUNCNAME}() requires 1 argument"
932 fi 1687 fi
933 1688
934 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1689 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
935 echo "CPython" 1690 echo "CPython"
936 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then 1691 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
937 echo "Jython" 1692 echo "Jython"
938 else 1693 else
1694 if [[ "${ignore_invalid}" == "0" ]]; then
939 die "${FUNCNAME}(): Unrecognized Python ABI '$1'" 1695 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
1696 fi
940 fi 1697 fi
941} 1698}
942 1699
943# @FUNCTION: PYTHON 1700# @FUNCTION: PYTHON
944# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}"> 1701# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}">
945# @DESCRIPTION: 1702# @DESCRIPTION:
946# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument 1703# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument
947# is ommitted, then PYTHON_ABI environment variable must be set and is used. 1704# is ommitted, then PYTHON_ABI environment variable must be set and is used.
948# If -2 option is specified, then active version of Python 2 is used. 1705# If -2 option is specified, then active version of CPython 2 is used.
949# If -3 option is specified, then active version of Python 3 is used. 1706# If -3 option is specified, then active version of CPython 3 is used.
950# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1707# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
951# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously. 1708# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously.
952# If --ABI option is specified, then only specified Python ABI is printed instead of 1709# If --ABI option is specified, then only specified Python ABI is printed instead of
953# filename of Python interpreter. 1710# filename of Python interpreter.
954# If --absolute-path option is specified, then absolute path to Python interpreter is printed. 1711# If --absolute-path option is specified, then absolute path to Python interpreter is printed.
955# --ABI and --absolute-path options cannot be specified simultaneously. 1712# --ABI and --absolute-path options cannot be specified simultaneously.
956PYTHON() { 1713PYTHON() {
1714 _python_check_python_pkg_setup_execution
1715
957 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0" 1716 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0"
958 1717
959 while (($#)); do 1718 while (($#)); do
960 case "$1" in 1719 case "$1" in
961 -2) 1720 -2)
986 esac 1745 esac
987 shift 1746 shift
988 done 1747 done
989 1748
990 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then 1749 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then
991 die "${FUNCNAME}(): '--ABI and '--absolute-path' options cannot be specified simultaneously" 1750 die "${FUNCNAME}(): '--ABI' and '--absolute-path' options cannot be specified simultaneously"
992 fi 1751 fi
993 1752
994 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then 1753 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then
995 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously" 1754 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously"
996 fi 1755 fi
997 1756
998 if [[ "$#" -eq 0 ]]; then 1757 if [[ "$#" -eq 0 ]]; then
999 if [[ "${final_ABI}" == "1" ]]; then 1758 if [[ "${final_ABI}" == "1" ]]; then
1000 if has "${EAPI:-0}" 0 1 2 3 4 && [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then 1759 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1001 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple versions of Python" 1760 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1002 fi 1761 fi
1003 validate_PYTHON_ABIS 1762 _python_calculate_PYTHON_ABIS
1004 PYTHON_ABI="${PYTHON_ABIS##* }" 1763 PYTHON_ABI="${PYTHON_ABIS##* }"
1005 elif [[ "${python2}" == "1" ]]; then 1764 elif [[ "${python2}" == "1" ]]; then
1006 PYTHON_ABI="$(eselect python show --python2 --ABI)" 1765 PYTHON_ABI="$(eselect python show --python2 --ABI)"
1007 if [[ -z "${PYTHON_ABI}" ]]; then 1766 if [[ -z "${PYTHON_ABI}" ]]; then
1008 die "${FUNCNAME}(): Active Python 2 interpreter not set" 1767 die "${FUNCNAME}(): Active version of CPython 2 not set"
1009 elif [[ "${PYTHON_ABI}" != "2."* ]]; then 1768 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1010 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`" 1769 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1011 fi 1770 fi
1012 elif [[ "${python3}" == "1" ]]; then 1771 elif [[ "${python3}" == "1" ]]; then
1013 PYTHON_ABI="$(eselect python show --python3 --ABI)" 1772 PYTHON_ABI="$(eselect python show --python3 --ABI)"
1014 if [[ -z "${PYTHON_ABI}" ]]; then 1773 if [[ -z "${PYTHON_ABI}" ]]; then
1015 die "${FUNCNAME}(): Active Python 3 interpreter not set" 1774 die "${FUNCNAME}(): Active version of CPython 3 not set"
1016 elif [[ "${PYTHON_ABI}" != "3."* ]]; then 1775 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1017 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`" 1776 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1018 fi 1777 fi
1019 elif [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then 1778 elif _python_package_supporting_installation_for_multiple_python_abis; then
1779 if ! _python_abi-specific_local_scope; then
1780 die "${FUNCNAME}() should be used in ABI-specific local scope"
1781 fi
1782 else
1020 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" 1783 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")"
1021 elif [[ -z "${PYTHON_ABI}" ]]; then 1784 if [[ -z "${PYTHON_ABI}" ]]; then
1022 die "${FUNCNAME}(): Invalid usage: Python ABI not specified" 1785 die "${FUNCNAME}(): Failure of extraction of locally active version of Python"
1786 fi
1023 fi 1787 fi
1024 elif [[ "$#" -eq 1 ]]; then 1788 elif [[ "$#" -eq 1 ]]; then
1025 if [[ "${final_ABI}" == "1" ]]; then 1789 if [[ "${final_ABI}" == "1" ]]; then
1026 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously" 1790 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously"
1027 fi 1791 fi
1041 return 1805 return
1042 else 1806 else
1043 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1807 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1044 python_interpreter="python${PYTHON_ABI}" 1808 python_interpreter="python${PYTHON_ABI}"
1045 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1809 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1046 python_interpreter="jython-${PYTHON_ABI%-jython}" 1810 python_interpreter="jython${PYTHON_ABI%-jython}"
1047 fi 1811 fi
1048 1812
1049 if [[ "${absolute_path_output}" == "1" ]]; then 1813 if [[ "${absolute_path_output}" == "1" ]]; then
1050 echo -n "${EPREFIX}/usr/bin/${python_interpreter}" 1814 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1051 else 1815 else
1062# @USAGE: [-f|--final-ABI] 1826# @USAGE: [-f|--final-ABI]
1063# @DESCRIPTION: 1827# @DESCRIPTION:
1064# Print name of Python implementation. 1828# Print name of Python implementation.
1065# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1829# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1066python_get_implementation() { 1830python_get_implementation() {
1831 _python_check_python_pkg_setup_execution
1832
1067 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1833 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1068 1834
1069 while (($#)); do 1835 while (($#)); do
1070 case "$1" in 1836 case "$1" in
1071 -f|--final-ABI) 1837 -f|--final-ABI)
1080 esac 1846 esac
1081 shift 1847 shift
1082 done 1848 done
1083 1849
1084 if [[ "${final_ABI}" == "1" ]]; then 1850 if [[ "${final_ABI}" == "1" ]]; then
1851 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1852 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1853 fi
1085 PYTHON_ABI="$(PYTHON -f --ABI)" 1854 PYTHON_ABI="$(PYTHON -f --ABI)"
1086 elif [[ -z "${PYTHON_ABI}" ]]; then 1855 else
1856 if _python_package_supporting_installation_for_multiple_python_abis; then
1857 if ! _python_abi-specific_local_scope; then
1858 die "${FUNCNAME}() should be used in ABI-specific local scope"
1859 fi
1860 else
1087 PYTHON_ABI="$(PYTHON --ABI)" 1861 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1862 fi
1088 fi 1863 fi
1089 1864
1090 echo "$(_python_get_implementation "${PYTHON_ABI}")" 1865 echo "$(_python_get_implementation "${PYTHON_ABI}")"
1091} 1866}
1092 1867
1094# @USAGE: [-f|--final-ABI] 1869# @USAGE: [-f|--final-ABI]
1095# @DESCRIPTION: 1870# @DESCRIPTION:
1096# Print category, name and slot of package providing Python implementation. 1871# Print category, name and slot of package providing Python implementation.
1097# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1872# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1098python_get_implementational_package() { 1873python_get_implementational_package() {
1874 _python_check_python_pkg_setup_execution
1875
1099 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1876 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1100 1877
1101 while (($#)); do 1878 while (($#)); do
1102 case "$1" in 1879 case "$1" in
1103 -f|--final-ABI) 1880 -f|--final-ABI)
1112 esac 1889 esac
1113 shift 1890 shift
1114 done 1891 done
1115 1892
1116 if [[ "${final_ABI}" == "1" ]]; then 1893 if [[ "${final_ABI}" == "1" ]]; then
1894 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1895 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1896 fi
1117 PYTHON_ABI="$(PYTHON -f --ABI)" 1897 PYTHON_ABI="$(PYTHON -f --ABI)"
1118 elif [[ -z "${PYTHON_ABI}" ]]; then 1898 else
1899 if _python_package_supporting_installation_for_multiple_python_abis; then
1900 if ! _python_abi-specific_local_scope; then
1901 die "${FUNCNAME}() should be used in ABI-specific local scope"
1902 fi
1903 else
1119 PYTHON_ABI="$(PYTHON --ABI)" 1904 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1120 fi 1905 fi
1906 fi
1121 1907
1908 if [[ "${EAPI:-0}" == "0" ]]; then
1122 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1909 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1123 echo "dev-lang/python:${PYTHON_ABI}" 1910 echo "=dev-lang/python-${PYTHON_ABI}*"
1124 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1911 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1912 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
1913 fi
1914 else
1915 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1916 echo "dev-lang/python:${PYTHON_ABI}"
1917 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1125 echo "dev-java/jython:${PYTHON_ABI%-jython}" 1918 echo "dev-java/jython:${PYTHON_ABI%-jython}"
1919 fi
1126 fi 1920 fi
1127} 1921}
1128 1922
1129# @FUNCTION: python_get_includedir 1923# @FUNCTION: python_get_includedir
1130# @USAGE: [-f|--final-ABI] 1924# @USAGE: [-b|--base-path] [-f|--final-ABI]
1131# @DESCRIPTION: 1925# @DESCRIPTION:
1132# Print path to Python include directory. 1926# Print path to Python include directory.
1927# If --base-path option is specified, then path not prefixed with "/" is printed.
1133# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1928# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1134python_get_includedir() { 1929python_get_includedir() {
1930 _python_check_python_pkg_setup_execution
1931
1135 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1932 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1933
1934 while (($#)); do
1935 case "$1" in
1936 -b|--base-path)
1937 base_path="1"
1938 ;;
1939 -f|--final-ABI)
1940 final_ABI="1"
1941 ;;
1942 -*)
1943 die "${FUNCNAME}(): Unrecognized option '$1'"
1944 ;;
1945 *)
1946 die "${FUNCNAME}(): Invalid usage"
1947 ;;
1948 esac
1949 shift
1950 done
1951
1952 if [[ "${base_path}" == "0" ]]; then
1953 prefix="/"
1954 fi
1955
1956 if [[ "${final_ABI}" == "1" ]]; then
1957 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1958 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1959 fi
1960 PYTHON_ABI="$(PYTHON -f --ABI)"
1961 else
1962 if _python_package_supporting_installation_for_multiple_python_abis; then
1963 if ! _python_abi-specific_local_scope; then
1964 die "${FUNCNAME}() should be used in ABI-specific local scope"
1965 fi
1966 else
1967 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1968 fi
1969 fi
1970
1971 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1972 echo "${prefix}usr/include/python${PYTHON_ABI}"
1973 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1974 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
1975 fi
1976}
1977
1978# @FUNCTION: python_get_libdir
1979# @USAGE: [-b|--base-path] [-f|--final-ABI]
1980# @DESCRIPTION:
1981# Print path to Python library directory.
1982# If --base-path option is specified, then path not prefixed with "/" is printed.
1983# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1984python_get_libdir() {
1985 _python_check_python_pkg_setup_execution
1986
1987 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1988
1989 while (($#)); do
1990 case "$1" in
1991 -b|--base-path)
1992 base_path="1"
1993 ;;
1994 -f|--final-ABI)
1995 final_ABI="1"
1996 ;;
1997 -*)
1998 die "${FUNCNAME}(): Unrecognized option '$1'"
1999 ;;
2000 *)
2001 die "${FUNCNAME}(): Invalid usage"
2002 ;;
2003 esac
2004 shift
2005 done
2006
2007 if [[ "${base_path}" == "0" ]]; then
2008 prefix="/"
2009 fi
2010
2011 if [[ "${final_ABI}" == "1" ]]; then
2012 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2013 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2014 fi
2015 PYTHON_ABI="$(PYTHON -f --ABI)"
2016 else
2017 if _python_package_supporting_installation_for_multiple_python_abis; then
2018 if ! _python_abi-specific_local_scope; then
2019 die "${FUNCNAME}() should be used in ABI-specific local scope"
2020 fi
2021 else
2022 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2023 fi
2024 fi
2025
2026 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2027 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
2028 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2029 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
2030 fi
2031}
2032
2033# @FUNCTION: python_get_sitedir
2034# @USAGE: [-b|--base-path] [-f|--final-ABI]
2035# @DESCRIPTION:
2036# Print path to Python site-packages directory.
2037# If --base-path option is specified, then path not prefixed with "/" is printed.
2038# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2039python_get_sitedir() {
2040 _python_check_python_pkg_setup_execution
2041
2042 local final_ABI="0" options=()
2043
2044 while (($#)); do
2045 case "$1" in
2046 -b|--base-path)
2047 options+=("$1")
2048 ;;
2049 -f|--final-ABI)
2050 final_ABI="1"
2051 options+=("$1")
2052 ;;
2053 -*)
2054 die "${FUNCNAME}(): Unrecognized option '$1'"
2055 ;;
2056 *)
2057 die "${FUNCNAME}(): Invalid usage"
2058 ;;
2059 esac
2060 shift
2061 done
2062
2063 if [[ "${final_ABI}" == "1" ]]; then
2064 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2065 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2066 fi
2067 else
2068 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2069 die "${FUNCNAME}() should be used in ABI-specific local scope"
2070 fi
2071 fi
2072
2073 echo "$(python_get_libdir "${options[@]}")/site-packages"
2074}
2075
2076# @FUNCTION: python_get_library
2077# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
2078# @DESCRIPTION:
2079# Print path to Python library.
2080# If --base-path option is specified, then path not prefixed with "/" is printed.
2081# If --linker-option is specified, then "-l${library}" linker option is printed.
2082# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2083python_get_library() {
2084 _python_check_python_pkg_setup_execution
2085
2086 local base_path="0" final_ABI="0" linker_option="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2087
2088 while (($#)); do
2089 case "$1" in
2090 -b|--base-path)
2091 base_path="1"
2092 ;;
2093 -f|--final-ABI)
2094 final_ABI="1"
2095 ;;
2096 -l|--linker-option)
2097 linker_option="1"
2098 ;;
2099 -*)
2100 die "${FUNCNAME}(): Unrecognized option '$1'"
2101 ;;
2102 *)
2103 die "${FUNCNAME}(): Invalid usage"
2104 ;;
2105 esac
2106 shift
2107 done
2108
2109 if [[ "${base_path}" == "0" ]]; then
2110 prefix="/"
2111 fi
2112
2113 if [[ "${base_path}" == "1" && "${linker_option}" == "1" ]]; then
2114 die "${FUNCNAME}(): '--base-path' and '--linker-option' options cannot be specified simultaneously"
2115 fi
2116
2117 if [[ "${final_ABI}" == "1" ]]; then
2118 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2119 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2120 fi
2121 PYTHON_ABI="$(PYTHON -f --ABI)"
2122 else
2123 if _python_package_supporting_installation_for_multiple_python_abis; then
2124 if ! _python_abi-specific_local_scope; then
2125 die "${FUNCNAME}() should be used in ABI-specific local scope"
2126 fi
2127 else
2128 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2129 fi
2130 fi
2131
2132 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2133 if [[ "${linker_option}" == "1" ]]; then
2134 echo "-lpython${PYTHON_ABI}"
2135 else
2136 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
2137 fi
2138 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2139 die "${FUNCNAME}(): Jython does not have shared library"
2140 fi
2141}
2142
2143# @FUNCTION: python_get_version
2144# @USAGE: [-f|--final-ABI] [-l|--language] [--full] [--major] [--minor] [--micro]
2145# @DESCRIPTION:
2146# Print Python version.
2147# --full, --major, --minor and --micro options cannot be specified simultaneously.
2148# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
2149# If --language option is specified, then Python language version is printed.
2150# --language and --full options cannot be specified simultaneously.
2151# --language and --micro options cannot be specified simultaneously.
2152# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2153python_get_version() {
2154 _python_check_python_pkg_setup_execution
2155
2156 local final_ABI="0" language="0" language_version full="0" major="0" minor="0" micro="0" PYTHON_ABI="${PYTHON_ABI}" python_command
1136 2157
1137 while (($#)); do 2158 while (($#)); do
1138 case "$1" in 2159 case "$1" in
1139 -f|--final-ABI) 2160 -f|--final-ABI)
1140 final_ABI="1" 2161 final_ABI="1"
1141 ;; 2162 ;;
2163 -l|--language)
2164 language="1"
2165 ;;
2166 --full)
2167 full="1"
2168 ;;
2169 --major)
2170 major="1"
2171 ;;
2172 --minor)
2173 minor="1"
2174 ;;
2175 --micro)
2176 micro="1"
2177 ;;
1142 -*) 2178 -*)
1143 die "${FUNCNAME}(): Unrecognized option '$1'" 2179 die "${FUNCNAME}(): Unrecognized option '$1'"
1144 ;; 2180 ;;
1145 *) 2181 *)
1146 die "${FUNCNAME}(): Invalid usage" 2182 die "${FUNCNAME}(): Invalid usage"
1148 esac 2184 esac
1149 shift 2185 shift
1150 done 2186 done
1151 2187
1152 if [[ "${final_ABI}" == "1" ]]; then 2188 if [[ "${final_ABI}" == "1" ]]; then
1153 PYTHON_ABI="$(PYTHON -f --ABI)" 2189 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1154 elif [[ -z "${PYTHON_ABI}" ]]; then 2190 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1155 PYTHON_ABI="$(PYTHON --ABI)"
1156 fi 2191 fi
1157
1158 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1159 echo "/usr/include/python${PYTHON_ABI}"
1160 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1161 echo "/usr/share/jython-${PYTHON_ABI%-jython}/Include"
1162 fi
1163}
1164
1165# @FUNCTION: python_get_libdir
1166# @USAGE: [-f|--final-ABI]
1167# @DESCRIPTION:
1168# Print path to Python library directory.
1169# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1170python_get_libdir() {
1171 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1172
1173 while (($#)); do
1174 case "$1" in
1175 -f|--final-ABI)
1176 final_ABI="1"
1177 ;;
1178 -*)
1179 die "${FUNCNAME}(): Unrecognized option '$1'"
1180 ;;
1181 *)
1182 die "${FUNCNAME}(): Invalid usage"
1183 ;;
1184 esac
1185 shift
1186 done
1187
1188 if [[ "${final_ABI}" == "1" ]]; then
1189 PYTHON_ABI="$(PYTHON -f --ABI)"
1190 elif [[ -z "${PYTHON_ABI}" ]]; then
1191 PYTHON_ABI="$(PYTHON --ABI)"
1192 fi
1193
1194 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1195 echo "/usr/$(get_libdir)/python${PYTHON_ABI}"
1196 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1197 echo "/usr/share/jython-${PYTHON_ABI%-jython}/Lib"
1198 fi
1199}
1200
1201# @FUNCTION: python_get_sitedir
1202# @USAGE: [-f|--final-ABI]
1203# @DESCRIPTION:
1204# Print path to Python site-packages directory.
1205# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1206python_get_sitedir() {
1207 local options=()
1208
1209 while (($#)); do
1210 case "$1" in
1211 -f|--final-ABI)
1212 options+=("$1")
1213 ;;
1214 -*)
1215 die "${FUNCNAME}(): Unrecognized option '$1'"
1216 ;;
1217 *)
1218 die "${FUNCNAME}(): Invalid usage"
1219 ;;
1220 esac
1221 shift
1222 done
1223
1224 echo "$(python_get_libdir "${options[@]}")/site-packages"
1225}
1226
1227# @FUNCTION: python_get_library
1228# @USAGE: [-f|--final-ABI] [-l|--linker-option]
1229# @DESCRIPTION:
1230# Print path to Python library.
1231# If --linker-option is specified, then "-l${library}" linker option is printed.
1232# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1233python_get_library() {
1234 local final_ABI="0" linker_option="0" PYTHON_ABI="${PYTHON_ABI}"
1235
1236 while (($#)); do
1237 case "$1" in
1238 -f|--final-ABI)
1239 final_ABI="1"
1240 ;;
1241 -l|--linker-option)
1242 linker_option="1"
1243 ;;
1244 -*)
1245 die "${FUNCNAME}(): Unrecognized option '$1'"
1246 ;;
1247 *)
1248 die "${FUNCNAME}(): Invalid usage"
1249 ;;
1250 esac
1251 shift
1252 done
1253
1254 if [[ "${final_ABI}" == "1" ]]; then
1255 PYTHON_ABI="$(PYTHON -f --ABI)"
1256 elif [[ -z "${PYTHON_ABI}" ]]; then
1257 PYTHON_ABI="$(PYTHON --ABI)"
1258 fi
1259
1260 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1261 if [[ "${linker_option}" == "1" ]]; then
1262 echo "-lpython${PYTHON_ABI}"
1263 else 2192 else
1264 echo "/usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)" 2193 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
1265 fi 2194 die "${FUNCNAME}() should be used in ABI-specific local scope"
1266 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1267 die "${FUNCNAME}(): Jython does not have shared library"
1268 fi 2195 fi
1269} 2196 fi
1270
1271# @FUNCTION: python_get_version
1272# @USAGE: [-f|--final-ABI] [--full] [--major] [--minor] [--micro]
1273# @DESCRIPTION:
1274# Print Python version.
1275# --full, --major, --minor and --micro options cannot be specified simultaneously.
1276# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
1277# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1278python_get_version() {
1279 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command
1280
1281 while (($#)); do
1282 case "$1" in
1283 -f|--final-ABI)
1284 final_ABI="1"
1285 ;;
1286 --full)
1287 full="1"
1288 ;;
1289 --major)
1290 major="1"
1291 ;;
1292 --minor)
1293 minor="1"
1294 ;;
1295 --micro)
1296 micro="1"
1297 ;;
1298 -*)
1299 die "${FUNCNAME}(): Unrecognized option '$1'"
1300 ;;
1301 *)
1302 die "${FUNCNAME}(): Invalid usage"
1303 ;;
1304 esac
1305 shift
1306 done
1307 2197
1308 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then 2198 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
1309 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously" 2199 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
1310 fi 2200 fi
1311 2201
1312 if [[ "${full}" == "1" ]]; then 2202 if [[ "${language}" == "1" ]]; then
1313 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
1314 elif [[ "${major}" == "1" ]]; then
1315 python_command="from sys import version_info; print(version_info[0])"
1316 elif [[ "${minor}" == "1" ]]; then
1317 python_command="from sys import version_info; print(version_info[1])"
1318 elif [[ "${micro}" == "1" ]]; then
1319 python_command="from sys import version_info; print(version_info[2])"
1320 else
1321 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
1322 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1323 echo "${PYTHON_ABI}"
1324 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1325 echo "${PYTHON_ABI%-jython}"
1326 fi
1327 return
1328 fi
1329 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
1330 fi
1331
1332 if [[ "${final_ABI}" == "1" ]]; then 2203 if [[ "${final_ABI}" == "1" ]]; then
1333 "$(PYTHON -f)" -c "${python_command}" 2204 PYTHON_ABI="$(PYTHON -f --ABI)"
1334 else 2205 elif [[ -z "${PYTHON_ABI}" ]]; then
1335 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
1336 fi
1337}
1338
1339# ================================================================================================
1340# =================================== MISCELLANEOUS FUNCTIONS ====================================
1341# ================================================================================================
1342
1343_python_implementation() {
1344 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
1345 return 0
1346 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
1347 return 0
1348 else
1349 return 1
1350 fi
1351}
1352
1353_python_initialize_prefix_variables() {
1354 if has "${EAPI:-0}" 0 1 2; then
1355 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
1356 EROOT="${ROOT%/}${EPREFIX}/"
1357 fi
1358 if [[ -n "${D}" && -z "${ED}" ]]; then
1359 ED="${D%/}${EPREFIX}/"
1360 fi
1361 fi
1362}
1363
1364unset PYTHON_SANITY_CHECKS
1365
1366_python_initial_sanity_checks() {
1367 if [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then
1368 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
1369 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
1370 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
1371 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
1372 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
1373 fi
1374 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
1375 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
1376 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
1377 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
1378 fi
1379 fi
1380}
1381
1382_python_final_sanity_checks() {
1383 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then
1384 local PYTHON_ABI="${PYTHON_ABI}" 2206 PYTHON_ABI="$(PYTHON --ABI)"
1385 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
1386 # Ensure that appropriate version of Python is installed.
1387 if ! has_version "$(python_get_implementational_package)"; then
1388 die "$(python_get_implementational_package) is not installed"
1389 fi 2207 fi
1390 2208 language_version="${PYTHON_ABI%%-*}"
1391 # Ensure that EPYTHON variable is respected.
1392 if [[ "$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" != "${PYTHON_ABI}" ]]; then
1393 eerror "python: '$(type -p python)'"
1394 eerror "ABI: '${ABI}'"
1395 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
1396 eerror "EPYTHON: '$(PYTHON)'"
1397 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
1398 eerror "Version of enabled Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
1399 die "'python' does not respect EPYTHON variable"
1400 fi
1401 done
1402 fi
1403 PYTHON_SANITY_CHECKS="1"
1404}
1405
1406_python_set_color_variables() {
1407 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
1408 _BOLD=$'\e[1m'
1409 _RED=$'\e[1;31m'
1410 _GREEN=$'\e[1;32m'
1411 _BLUE=$'\e[1;34m'
1412 _CYAN=$'\e[1;36m'
1413 _NORMAL=$'\e[0m'
1414 else
1415 _BOLD=
1416 _RED=
1417 _GREEN=
1418 _BLUE=
1419 _CYAN=
1420 _NORMAL=
1421 fi
1422}
1423
1424# @FUNCTION: python_convert_shebangs
1425# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories]
1426# @DESCRIPTION:
1427# Convert shebangs in specified files. Directories can be specified only with --recursive option.
1428python_convert_shebangs() {
1429 local argument file files=() only_executables="0" python_version quiet="0" recursive="0"
1430
1431 while (($#)); do
1432 case "$1" in
1433 -r|--recursive)
1434 recursive="1"
1435 ;;
1436 -q|--quiet)
1437 quiet="1"
1438 ;;
1439 -x|--only-executables)
1440 only_executables="1"
1441 ;;
1442 --)
1443 shift
1444 break
1445 ;;
1446 -*)
1447 die "${FUNCNAME}(): Unrecognized option '$1'"
1448 ;;
1449 *)
1450 break
1451 ;;
1452 esac
1453 shift
1454 done
1455
1456 if [[ "$#" -eq 0 ]]; then
1457 die "${FUNCNAME}(): Missing Python version and files or directories"
1458 elif [[ "$#" -eq 1 ]]; then
1459 die "${FUNCNAME}(): Missing files or directories"
1460 fi
1461
1462 python_version="$1"
1463 shift
1464
1465 for argument in "$@"; do
1466 if [[ ! -e "${argument}" ]]; then
1467 die "${FUNCNAME}(): '${argument}' does not exist"
1468 elif [[ -f "${argument}" ]]; then
1469 files+=("${argument}")
1470 elif [[ -d "${argument}" ]]; then
1471 if [[ "${recursive}" == "1" ]]; then 2209 if [[ "${full}" == "1" ]]; then
1472 if [[ "${only_executables}" == "1" ]]; then 2210 die "${FUNCNAME}(): '--language' and '--full' options cannot be specified simultaneously"
1473 files+=($(find "${argument}" -perm /111 -type f)) 2211 elif [[ "${major}" == "1" ]]; then
1474 else 2212 echo "${language_version%.*}"
1475 files+=($(find "${argument}" -type f)) 2213 elif [[ "${minor}" == "1" ]]; then
1476 fi 2214 echo "${language_version#*.}"
1477 else 2215 elif [[ "${micro}" == "1" ]]; then
1478 die "${FUNCNAME}(): '${argument}' is not a regular file" 2216 die "${FUNCNAME}(): '--language' and '--micro' options cannot be specified simultaneously"
1479 fi
1480 else 2217 else
1481 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory" 2218 echo "${language_version}"
1482 fi 2219 fi
1483 done 2220 else
1484
1485 for file in "${files[@]}"; do
1486 file="${file#./}"
1487 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
1488
1489 if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then
1490 if [[ "${quiet}" == "0" ]]; then 2221 if [[ "${full}" == "1" ]]; then
1491 einfo "Converting shebang in '${file}'" 2222 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
2223 elif [[ "${major}" == "1" ]]; then
2224 python_command="from sys import version_info; print(version_info[0])"
2225 elif [[ "${minor}" == "1" ]]; then
2226 python_command="from sys import version_info; print(version_info[1])"
2227 elif [[ "${micro}" == "1" ]]; then
2228 python_command="from sys import version_info; print(version_info[2])"
2229 else
2230 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2231 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2232 echo "${PYTHON_ABI}"
2233 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2234 echo "${PYTHON_ABI%-jython}"
1492 fi 2235 fi
1493 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed" 2236 return
1494
1495 # Delete potential whitespace after "#!".
1496 sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed"
1497 fi 2237 fi
1498 done 2238 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2239 fi
2240
2241 if [[ "${final_ABI}" == "1" ]]; then
2242 "$(PYTHON -f)" -c "${python_command}"
2243 else
2244 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
2245 fi
2246 fi
1499} 2247}
1500 2248
1501# ================================================================================================ 2249# ================================================================================================
1502# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================ 2250# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
1503# ================================================================================================ 2251# ================================================================================================
1511_python_test_hook() { 2259_python_test_hook() {
1512 if [[ "$#" -ne 1 ]]; then 2260 if [[ "$#" -ne 1 ]]; then
1513 die "${FUNCNAME}() requires 1 argument" 2261 die "${FUNCNAME}() requires 1 argument"
1514 fi 2262 fi
1515 2263
1516 if [[ -n "${SUPPORT_PYTHON_ABIS}" && "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then 2264 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then
1517 "${FUNCNAME[3]}_$1_hook" 2265 "${FUNCNAME[3]}_$1_hook"
1518 fi 2266 fi
1519} 2267}
1520 2268
1521# @FUNCTION: python_execute_nosetests 2269# @FUNCTION: python_execute_nosetests
1522# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2270# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1523# @DESCRIPTION: 2271# @DESCRIPTION:
1524# Execute nosetests for all enabled versions of Python. 2272# Execute nosetests for all enabled Python ABIs.
1525# In ebuilds of packages supporting installation for multiple versions of Python, this function 2273# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1526# calls python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined. 2274# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined.
1527python_execute_nosetests() { 2275python_execute_nosetests() {
2276 _python_check_python_pkg_setup_execution
1528 _python_set_color_variables 2277 _python_set_color_variables
1529 2278
1530 local PYTHONPATH_template= separate_build_dirs= 2279 local PYTHONPATH_template separate_build_dirs
1531 2280
1532 while (($#)); do 2281 while (($#)); do
1533 case "$1" in 2282 case "$1" in
1534 -P|--PYTHONPATH) 2283 -P|--PYTHONPATH)
1535 PYTHONPATH_template="$2" 2284 PYTHONPATH_template="$2"
1551 esac 2300 esac
1552 shift 2301 shift
1553 done 2302 done
1554 2303
1555 python_test_function() { 2304 python_test_function() {
1556 local evaluated_PYTHONPATH= 2305 local evaluated_PYTHONPATH
1557 2306
1558 if [[ -n "${PYTHONPATH_template}" ]]; then
1559 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2307 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1560 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1561 unset evaluated_PYTHONPATH
1562 fi
1563 fi
1564 2308
1565 _python_test_hook pre 2309 _python_test_hook pre
1566 2310
1567 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2311 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1568 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2312 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
1572 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2316 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
1573 fi 2317 fi
1574 2318
1575 _python_test_hook post 2319 _python_test_hook post
1576 } 2320 }
1577 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2321 if _python_package_supporting_installation_for_multiple_python_abis; then
1578 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2322 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1579 else 2323 else
1580 if [[ -n "${separate_build_dirs}" ]]; then 2324 if [[ -n "${separate_build_dirs}" ]]; then
1581 die "${FUNCNAME}(): Invalid usage" 2325 die "${FUNCNAME}(): Invalid usage"
1582 fi 2326 fi
1587} 2331}
1588 2332
1589# @FUNCTION: python_execute_py.test 2333# @FUNCTION: python_execute_py.test
1590# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2334# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1591# @DESCRIPTION: 2335# @DESCRIPTION:
1592# Execute py.test for all enabled versions of Python. 2336# Execute py.test for all enabled Python ABIs.
1593# In ebuilds of packages supporting installation for multiple versions of Python, this function 2337# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1594# calls python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined. 2338# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined.
1595python_execute_py.test() { 2339python_execute_py.test() {
2340 _python_check_python_pkg_setup_execution
1596 _python_set_color_variables 2341 _python_set_color_variables
1597 2342
1598 local PYTHONPATH_template= separate_build_dirs= 2343 local PYTHONPATH_template separate_build_dirs
1599 2344
1600 while (($#)); do 2345 while (($#)); do
1601 case "$1" in 2346 case "$1" in
1602 -P|--PYTHONPATH) 2347 -P|--PYTHONPATH)
1603 PYTHONPATH_template="$2" 2348 PYTHONPATH_template="$2"
1619 esac 2364 esac
1620 shift 2365 shift
1621 done 2366 done
1622 2367
1623 python_test_function() { 2368 python_test_function() {
1624 local evaluated_PYTHONPATH= 2369 local evaluated_PYTHONPATH
1625 2370
1626 if [[ -n "${PYTHONPATH_template}" ]]; then
1627 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2371 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1628 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1629 unset evaluated_PYTHONPATH
1630 fi
1631 fi
1632 2372
1633 _python_test_hook pre 2373 _python_test_hook pre
1634 2374
1635 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2375 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1636 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL} 2376 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
1640 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?" 2380 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
1641 fi 2381 fi
1642 2382
1643 _python_test_hook post 2383 _python_test_hook post
1644 } 2384 }
1645 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2385 if _python_package_supporting_installation_for_multiple_python_abis; then
1646 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2386 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1647 else 2387 else
1648 if [[ -n "${separate_build_dirs}" ]]; then 2388 if [[ -n "${separate_build_dirs}" ]]; then
1649 die "${FUNCNAME}(): Invalid usage" 2389 die "${FUNCNAME}(): Invalid usage"
1650 fi 2390 fi
1655} 2395}
1656 2396
1657# @FUNCTION: python_execute_trial 2397# @FUNCTION: python_execute_trial
1658# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2398# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1659# @DESCRIPTION: 2399# @DESCRIPTION:
1660# Execute trial for all enabled versions of Python. 2400# Execute trial for all enabled Python ABIs.
1661# In ebuilds of packages supporting installation for multiple versions of Python, this function 2401# In ebuilds of packages supporting installation for multiple Python ABIs, this function
1662# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined. 2402# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined.
1663python_execute_trial() { 2403python_execute_trial() {
2404 _python_check_python_pkg_setup_execution
1664 _python_set_color_variables 2405 _python_set_color_variables
1665 2406
1666 local PYTHONPATH_template= separate_build_dirs= 2407 local PYTHONPATH_template separate_build_dirs
1667 2408
1668 while (($#)); do 2409 while (($#)); do
1669 case "$1" in 2410 case "$1" in
1670 -P|--PYTHONPATH) 2411 -P|--PYTHONPATH)
1671 PYTHONPATH_template="$2" 2412 PYTHONPATH_template="$2"
1687 esac 2428 esac
1688 shift 2429 shift
1689 done 2430 done
1690 2431
1691 python_test_function() { 2432 python_test_function() {
1692 local evaluated_PYTHONPATH= 2433 local evaluated_PYTHONPATH
1693 2434
1694 if [[ -n "${PYTHONPATH_template}" ]]; then
1695 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2435 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1696 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1697 unset evaluated_PYTHONPATH
1698 fi
1699 fi
1700 2436
1701 _python_test_hook pre 2437 _python_test_hook pre
1702 2438
1703 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2439 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1704 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2440 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
1708 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2444 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
1709 fi 2445 fi
1710 2446
1711 _python_test_hook post 2447 _python_test_hook post
1712 } 2448 }
1713 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2449 if _python_package_supporting_installation_for_multiple_python_abis; then
1714 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2450 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1715 else 2451 else
1716 if [[ -n "${separate_build_dirs}" ]]; then 2452 if [[ -n "${separate_build_dirs}" ]]; then
1717 die "${FUNCNAME}(): Invalid usage" 2453 die "${FUNCNAME}(): Invalid usage"
1718 fi 2454 fi
1729# @FUNCTION: python_enable_pyc 2465# @FUNCTION: python_enable_pyc
1730# @DESCRIPTION: 2466# @DESCRIPTION:
1731# Tell Python to automatically recompile modules to .pyc/.pyo if the 2467# Tell Python to automatically recompile modules to .pyc/.pyo if the
1732# timestamps/version stamps have changed. 2468# timestamps/version stamps have changed.
1733python_enable_pyc() { 2469python_enable_pyc() {
2470 _python_check_python_pkg_setup_execution
2471
2472 if [[ "$#" -ne 0 ]]; then
2473 die "${FUNCNAME}() does not accept arguments"
2474 fi
2475
1734 unset PYTHONDONTWRITEBYTECODE 2476 unset PYTHONDONTWRITEBYTECODE
1735} 2477}
1736 2478
1737# @FUNCTION: python_disable_pyc 2479# @FUNCTION: python_disable_pyc
1738# @DESCRIPTION: 2480# @DESCRIPTION:
1739# Tell Python not to automatically recompile modules to .pyc/.pyo 2481# Tell Python not to automatically recompile modules to .pyc/.pyo
1740# even if the timestamps/version stamps do not match. This is done 2482# even if the timestamps/version stamps do not match. This is done
1741# to protect sandbox. 2483# to protect sandbox.
1742python_disable_pyc() { 2484python_disable_pyc() {
2485 _python_check_python_pkg_setup_execution
2486
2487 if [[ "$#" -ne 0 ]]; then
2488 die "${FUNCNAME}() does not accept arguments"
2489 fi
2490
1743 export PYTHONDONTWRITEBYTECODE="1" 2491 export PYTHONDONTWRITEBYTECODE="1"
1744} 2492}
1745 2493
2494_python_clean_compiled_modules() {
2495 _python_initialize_prefix_variables
2496 _python_set_color_variables
2497
2498 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage"
2499
2500 local base_module_name compiled_file compiled_files=() dir path py_file root
2501
2502 # Strip trailing slash from EROOT.
2503 root="${EROOT%/}"
2504
2505 for path in "$@"; do
2506 compiled_files=()
2507 if [[ -d "${path}" ]]; then
2508 while read -d $'\0' -r compiled_file; do
2509 compiled_files+=("${compiled_file}")
2510 done < <(find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0)
2511
2512 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then
2513 # Delete empty child directories.
2514 find "${path}" -type d | sort -r | while read -r dir; do
2515 if rmdir "${dir}" 2> /dev/null; then
2516 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2517 fi
2518 done
2519 fi
2520 elif [[ "${path}" == *.py ]]; then
2521 base_module_name="${path##*/}"
2522 base_module_name="${base_module_name%.py}"
2523 if [[ -d "${path%/*}/__pycache__" ]]; then
2524 while read -d $'\0' -r compiled_file; do
2525 compiled_files+=("${compiled_file}")
2526 done < <(find "${path%/*}/__pycache__" "(" -name "${base_module_name}.*.py[co]" -o -name "${base_module_name}\$py.class" ")" -print0)
2527 fi
2528 compiled_files+=("${path}c" "${path}o" "${path%.py}\$py.class")
2529 fi
2530
2531 for compiled_file in "${compiled_files[@]}"; do
2532 [[ ! -f "${compiled_file}" ]] && continue
2533 dir="${compiled_file%/*}"
2534 dir="${dir##*/}"
2535 if [[ "${compiled_file}" == *.py[co] ]]; then
2536 if [[ "${dir}" == "__pycache__" ]]; then
2537 base_module_name="${compiled_file##*/}"
2538 base_module_name="${base_module_name%.*py[co]}"
2539 base_module_name="${base_module_name%.*}"
2540 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2541 else
2542 py_file="${compiled_file%[co]}"
2543 fi
2544 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2545 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2546 else
2547 [[ -f "${py_file}" ]] && continue
2548 fi
2549 echo "${_BLUE}<<< ${compiled_file%[co]}[co]${_NORMAL}"
2550 rm -f "${compiled_file%[co]}"[co]
2551 elif [[ "${compiled_file}" == *\$py.class ]]; then
2552 if [[ "${dir}" == "__pycache__" ]]; then
2553 base_module_name="${compiled_file##*/}"
2554 base_module_name="${base_module_name%\$py.class}"
2555 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2556 else
2557 py_file="${compiled_file%\$py.class}.py"
2558 fi
2559 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2560 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2561 else
2562 [[ -f "${py_file}" ]] && continue
2563 fi
2564 echo "${_BLUE}<<< ${compiled_file}${_NORMAL}"
2565 rm -f "${compiled_file}"
2566 else
2567 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'"
2568 fi
2569
2570 # Delete empty parent directories.
2571 dir="${compiled_file%/*}"
2572 while [[ "${dir}" != "${root}" ]]; do
2573 if rmdir "${dir}" 2> /dev/null; then
2574 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2575 else
2576 break
2577 fi
2578 dir="${dir%/*}"
2579 done
2580 done
2581 done
2582}
2583
1746# @FUNCTION: python_mod_optimize 2584# @FUNCTION: python_mod_optimize
1747# @USAGE: [options] [directory|file] 2585# @USAGE: [--allow-evaluated-non-sitedir-paths] [-d directory] [-f] [-l] [-q] [-x regular_expression] [--] <file|directory> [files|directories]
1748# @DESCRIPTION: 2586# @DESCRIPTION:
1749# If no arguments supplied, it will recompile not recursively all modules 2587# Byte-compile specified Python modules.
1750# under sys.path (eg. /usr/lib/python2.6, /usr/lib/python2.6/site-packages).
1751#
1752# If supplied with arguments, it will recompile all modules recursively
1753# in the supplied directory.
1754#
1755# Options passed to this function are passed to compileall.py. 2588# -d, -f, -l, -q and -x options passed to this function are passed to compileall.py.
1756# 2589#
1757# This function can be used only in pkg_postinst() phase. 2590# This function can be used only in pkg_postinst() phase.
1758python_mod_optimize() { 2591python_mod_optimize() {
2592 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then
2593 die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2594 fi
2595
2596 _python_check_python_pkg_setup_execution
1759 _python_initialize_prefix_variables 2597 _python_initialize_prefix_variables
1760 2598
1761 # Check if phase is pkg_postinst(). 2599 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
1762 [[ ${EBUILD_PHASE} != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase" 2600 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs.
2601 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() stderr stderr_line
1763 2602
2603 if _python_package_supporting_installation_for_multiple_python_abis; then
1764 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2604 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
1765 local dir file options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_absolute_dirs=() site_packages_dirs=() site_packages_absolute_files=() site_packages_files=() 2605 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2606 fi
2607 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2608 else
2609 if has "${EAPI:-0}" 0 1 2 3; then
2610 iterated_PYTHON_ABIS="${PYTHON_ABI:=$(PYTHON --ABI)}"
2611 else
2612 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2613 fi
2614 fi
1766 2615
1767 # Strip trailing slash from ROOT. 2616 # Strip trailing slash from EROOT.
1768 root="${EROOT%/}" 2617 root="${EROOT%/}"
1769 2618
1770 # Respect ROOT and options passed to compileall.py.
1771 while (($#)); do 2619 while (($#)); do
1772 case "$1" in 2620 case "$1" in
2621 --allow-evaluated-non-sitedir-paths)
2622 allow_evaluated_non_sitedir_paths="1"
2623 ;;
1773 -l|-f|-q) 2624 -l|-f|-q)
1774 options+=("$1") 2625 options+=("$1")
1775 ;; 2626 ;;
1776 -d|-x) 2627 -d|-x)
1777 options+=("$1" "$2") 2628 options+=("$1" "$2")
1778 shift 2629 shift
1779 ;; 2630 ;;
2631 --)
2632 shift
2633 break
2634 ;;
1780 -*) 2635 -*)
1781 ewarn "${FUNCNAME}(): Ignoring option '$1'" 2636 die "${FUNCNAME}(): Unrecognized option '$1'"
1782 ;; 2637 ;;
1783 *) 2638 *)
1784 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
1785 die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories"
1786 elif [[ "$1" =~ ^/ ]]; then
1787 if [[ -d "${root}/$1" ]]; then
1788 other_dirs+=("${root}/$1")
1789 elif [[ -f "${root}/$1" ]]; then
1790 other_files+=("${root}/$1")
1791 elif [[ -e "${root}/$1" ]]; then
1792 ewarn "'${root}/$1' is not a file or a directory!"
1793 else
1794 ewarn "'${root}/$1' does not exist!"
1795 fi
1796 else
1797 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do
1798 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
1799 site_packages_dirs+=("$1")
1800 break 2639 break
1801 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
1802 site_packages_files+=("$1")
1803 break
1804 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
1805 ewarn "'$1' is not a file or a directory!"
1806 else
1807 ewarn "'$1' does not exist!"
1808 fi
1809 done
1810 fi
1811 ;; 2640 ;;
1812 esac 2641 esac
1813 shift 2642 shift
1814 done 2643 done
1815 2644
2645 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2646 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2647 fi
2648
2649 if [[ "$#" -eq 0 ]]; then
2650 die "${FUNCNAME}(): Missing files or directories"
2651 fi
2652
2653 while (($#)); do
2654 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2655 die "${FUNCNAME}(): Invalid argument '$1'"
2656 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
2657 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
2658 elif [[ "$1" =~ ^/ ]]; then
2659 if _python_package_supporting_installation_for_multiple_python_abis; then
2660 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2661 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2662 fi
2663 if [[ "$1" != *\$* ]]; then
2664 die "${FUNCNAME}(): '$1' has invalid syntax"
2665 fi
2666 if [[ "$1" == *.py ]]; then
2667 evaluated_files+=("$1")
2668 else
2669 evaluated_dirs+=("$1")
2670 fi
2671 else
2672 if [[ -d "${root}$1" ]]; then
2673 other_dirs+=("${root}$1")
2674 elif [[ -f "${root}$1" ]]; then
2675 other_files+=("${root}$1")
2676 elif [[ -e "${root}$1" ]]; then
2677 eerror "${FUNCNAME}(): '${root}$1' is not a regular file or a directory"
2678 else
2679 eerror "${FUNCNAME}(): '${root}$1' does not exist"
2680 fi
2681 fi
2682 else
2683 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2684 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
2685 site_packages_dirs+=("$1")
2686 break
2687 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
2688 site_packages_files+=("$1")
2689 break
2690 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
2691 eerror "${FUNCNAME}(): '$1' is not a regular file or a directory"
2692 else
2693 eerror "${FUNCNAME}(): '$1' does not exist"
2694 fi
2695 done
2696 fi
2697 shift
2698 done
2699
1816 # Set additional options. 2700 # Set additional options.
1817 options+=("-q") 2701 options+=("-q")
1818 2702
1819 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do 2703 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1820 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then 2704 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
1821 return_code="0" 2705 return_code="0"
2706 stderr=""
1822 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)" 2707 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
1823 if ((${#site_packages_dirs[@]})); then 2708 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
1824 for dir in "${site_packages_dirs[@]}"; do 2709 for dir in "${site_packages_dirs[@]}"; do
1825 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}") 2710 dirs+=("${root}$(python_get_sitedir)/${dir}")
1826 done 2711 done
2712 for dir in "${evaluated_dirs[@]}"; do
2713 eval "dirs+=(\"\${root}${dir}\")"
2714 done
1827 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1" 2715 stderr+="${stderr:+$'\n'}$("$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1"
1828 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2716 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1829 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1" 2717 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
1830 fi 2718 fi
2719 _python_clean_compiled_modules "${dirs[@]}"
1831 fi 2720 fi
1832 if ((${#site_packages_files[@]})); then 2721 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
1833 for file in "${site_packages_files[@]}"; do 2722 for file in "${site_packages_files[@]}"; do
1834 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}") 2723 files+=("${root}$(python_get_sitedir)/${file}")
1835 done 2724 done
2725 for file in "${evaluated_files[@]}"; do
2726 eval "files+=(\"\${root}${file}\")"
2727 done
1836 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1" 2728 stderr+="${stderr:+$'\n'}$("$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" 2>&1)" || return_code="1"
1837 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2729 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1838 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1" 2730 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" &> /dev/null || return_code="1"
1839 fi 2731 fi
2732 _python_clean_compiled_modules "${files[@]}"
1840 fi 2733 fi
1841 eend "${return_code}" 2734 eend "${return_code}"
2735 if [[ -n "${stderr}" ]]; then
2736 eerror "Syntax errors / warnings in Python modules for $(python_get_implementation) $(python_get_version):" &> /dev/null
2737 while read stderr_line; do
2738 eerror " ${stderr_line}"
2739 done <<< "${stderr}"
1842 fi 2740 fi
1843 unset site_packages_absolute_dirs site_packages_absolute_files 2741 fi
2742 unset dirs files
1844 done 2743 done
1845 2744
2745 if _python_package_supporting_installation_for_multiple_python_abis; then
1846 # Restore previous value of PYTHON_ABI. 2746 # Restore previous value of PYTHON_ABI.
1847 if [[ -n "${previous_PYTHON_ABI}" ]]; then 2747 if [[ -n "${previous_PYTHON_ABI}" ]]; then
1848 PYTHON_ABI="${previous_PYTHON_ABI}" 2748 PYTHON_ABI="${previous_PYTHON_ABI}"
1849 else 2749 else
1850 unset PYTHON_ABI 2750 unset PYTHON_ABI
2751 fi
1851 fi 2752 fi
1852 2753
1853 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2754 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
1854 return_code="0" 2755 return_code="0"
2756 stderr=""
1855 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)" 2757 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)"
1856 if ((${#other_dirs[@]})); then 2758 if ((${#other_dirs[@]})); then
1857 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 2759 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1"
1858 if [[ "$(_python_get_implementation "${PYTHON_ABI-$(PYTHON --ABI)}")" != "Jython" ]]; then 2760 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1859 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2761 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
1860 fi 2762 fi
2763 _python_clean_compiled_modules "${other_dirs[@]}"
1861 fi 2764 fi
1862 if ((${#other_files[@]})); then 2765 if ((${#other_files[@]})); then
1863 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 2766 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" 2>&1)" || return_code="1"
1864 if [[ "$(_python_get_implementation "${PYTHON_ABI-$(PYTHON --ABI)}")" != "Jython" ]]; then 2767 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1865 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2768 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1"
1866 fi 2769 fi
2770 _python_clean_compiled_modules "${other_files[@]}"
1867 fi 2771 fi
1868 eend "${return_code}" 2772 eend "${return_code}"
2773 if [[ -n "${stderr}" ]]; then
2774 eerror "Syntax errors / warnings in Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version):" &> /dev/null
2775 while read stderr_line; do
2776 eerror " ${stderr_line}"
2777 done <<< "${stderr}"
1869 fi 2778 fi
2779 fi
1870 else 2780 else
2781 # Deprecated part of python_mod_optimize()
2782 ewarn
2783 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2784 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
2785 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
2786 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
2787 ewarn
2788
1871 local myroot mydirs=() myfiles=() myopts=() return_code="0" 2789 local myroot mydirs=() myfiles=() myopts=() return_code="0"
1872 2790
1873 # strip trailing slash 2791 # strip trailing slash
1874 myroot="${EROOT%/}" 2792 myroot="${EROOT%/}"
1875 2793
1876 # respect ROOT and options passed to compileall.py 2794 # respect EROOT and options passed to compileall.py
1877 while (($#)); do 2795 while (($#)); do
1878 case "$1" in 2796 case "$1" in
1879 -l|-f|-q) 2797 -l|-f|-q)
1880 myopts+=("$1") 2798 myopts+=("$1")
1881 ;; 2799 ;;
1882 -d|-x) 2800 -d|-x)
1883 myopts+=("$1" "$2") 2801 myopts+=("$1" "$2")
1884 shift 2802 shift
1885 ;; 2803 ;;
2804 --)
2805 shift
2806 break
2807 ;;
1886 -*) 2808 -*)
1887 ewarn "${FUNCNAME}(): Ignoring option '$1'" 2809 die "${FUNCNAME}(): Unrecognized option '$1'"
1888 ;; 2810 ;;
1889 *) 2811 *)
1890 if [[ -d "${myroot}"/$1 ]]; then 2812 break
1891 mydirs+=("${myroot}/$1")
1892 elif [[ -f "${myroot}"/$1 ]]; then
1893 # Files are passed to python_mod_compile which is ROOT-aware
1894 myfiles+=("$1")
1895 elif [[ -e "${myroot}/$1" ]]; then
1896 ewarn "${myroot}/$1 is not a file or directory!"
1897 else
1898 ewarn "${myroot}/$1 does not exist!"
1899 fi
1900 ;; 2813 ;;
1901 esac 2814 esac
1902 shift 2815 shift
1903 done 2816 done
1904 2817
2818 if [[ "$#" -eq 0 ]]; then
2819 die "${FUNCNAME}(): Missing files or directories"
2820 fi
2821
2822 while (($#)); do
2823 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2824 die "${FUNCNAME}(): Invalid argument '$1'"
2825 elif [[ -d "${myroot}/${1#/}" ]]; then
2826 mydirs+=("${myroot}/${1#/}")
2827 elif [[ -f "${myroot}/${1#/}" ]]; then
2828 myfiles+=("${myroot}/${1#/}")
2829 elif [[ -e "${myroot}/${1#/}" ]]; then
2830 eerror "${FUNCNAME}(): ${myroot}/${1#/} is not a regular file or directory"
2831 else
2832 eerror "${FUNCNAME}(): ${myroot}/${1#/} does not exist"
2833 fi
2834 shift
2835 done
2836
1905 # set additional opts 2837 # set additional opts
1906 myopts+=(-q) 2838 myopts+=(-q)
2839
2840 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1907 2841
1908 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)" 2842 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
1909 if ((${#mydirs[@]})); then 2843 if ((${#mydirs[@]})); then
1910 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1" 2844 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1"
1911 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1" 2845 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
2846 _python_clean_compiled_modules "${mydirs[@]}"
1912 fi 2847 fi
1913 2848
1914 if ((${#myfiles[@]})); then 2849 if ((${#myfiles[@]})); then
2850 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" || return_code="1"
2851 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null || return_code="1"
1915 python_mod_compile "${myfiles[@]}" 2852 _python_clean_compiled_modules "${myfiles[@]}"
1916 fi 2853 fi
1917 2854
1918 eend "${return_code}" 2855 eend "${return_code}"
1919 fi 2856 fi
1920} 2857}
1921 2858
1922# @FUNCTION: python_mod_cleanup 2859# @FUNCTION: python_mod_cleanup
1923# @USAGE: [directory|file] 2860# @USAGE: [--allow-evaluated-non-sitedir-paths] [--] <file|directory> [files|directories]
1924# @DESCRIPTION: 2861# @DESCRIPTION:
1925# Run with optional arguments, where arguments are Python modules. If none given, 2862# Delete orphaned byte-compiled Python modules corresponding to specified Python modules.
1926# it will look in /usr/lib/python[0-9].[0-9].
1927#
1928# It will recursively scan all compiled Python modules in the directories and
1929# determine if they are orphaned (i.e. their corresponding .py files are missing.)
1930# If they are, then it will remove their corresponding .pyc and .pyo files.
1931# 2863#
1932# This function can be used only in pkg_postrm() phase. 2864# This function can be used only in pkg_postrm() phase.
1933python_mod_cleanup() { 2865python_mod_cleanup() {
2866 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then
2867 die "${FUNCNAME}() can be used only in pkg_postrm() phase"
2868 fi
2869
2870 _python_check_python_pkg_setup_execution
1934 _python_initialize_prefix_variables 2871 _python_initialize_prefix_variables
1935 _python_set_color_variables
1936 2872
1937 local path py_file PYTHON_ABI="${PYTHON_ABI}" SEARCH_PATH=() root 2873 local allow_evaluated_non_sitedir_paths="0" dir iterated_PYTHON_ABIS PYTHON_ABI="${PYTHON_ABI}" root search_paths=() sitedir
1938 2874
1939 # Check if phase is pkg_postrm(). 2875 if _python_package_supporting_installation_for_multiple_python_abis; then
1940 [[ ${EBUILD_PHASE} != "postrm" ]] && die "${FUNCNAME}() can be used only in pkg_postrm() phase" 2876 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2877 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2878 fi
2879 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2880 else
2881 if has "${EAPI:-0}" 0 1 2 3; then
2882 iterated_PYTHON_ABIS="${PYTHON_ABI:-$(PYTHON --ABI)}"
2883 else
2884 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2885 fi
2886 fi
1941 2887
1942 # Strip trailing slash from ROOT. 2888 # Strip trailing slash from EROOT.
1943 root="${EROOT%/}" 2889 root="${EROOT%/}"
1944 2890
1945 if (($#)); then 2891 while (($#)); do
1946 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2892 case "$1" in
2893 --allow-evaluated-non-sitedir-paths)
2894 allow_evaluated_non_sitedir_paths="1"
2895 ;;
2896 --)
2897 shift
2898 break
2899 ;;
2900 -*)
2901 die "${FUNCNAME}(): Unrecognized option '$1'"
2902 ;;
2903 *)
2904 break
2905 ;;
2906 esac
2907 shift
2908 done
2909
2910 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2911 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2912 fi
2913
2914 if [[ "$#" -eq 0 ]]; then
2915 die "${FUNCNAME}(): Missing files or directories"
2916 fi
2917
2918 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
1947 while (($#)); do 2919 while (($#)); do
2920 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2921 die "${FUNCNAME}(): Invalid argument '$1'"
1948 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 2922 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
1949 die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories" 2923 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
1950 elif [[ "$1" =~ ^/ ]]; then 2924 elif [[ "$1" =~ ^/ ]]; then
1951 SEARCH_PATH+=("${root}/${1#/}") 2925 if _python_package_supporting_installation_for_multiple_python_abis; then
2926 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2927 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2928 fi
2929 if [[ "$1" != *\$* ]]; then
2930 die "${FUNCNAME}(): '$1' has invalid syntax"
2931 fi
2932 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2933 eval "search_paths+=(\"\${root}$1\")"
2934 done
1952 else 2935 else
1953 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do 2936 search_paths+=("${root}$1")
1954 SEARCH_PATH+=("${root}$(python_get_sitedir)/$1")
1955 done
1956 fi
1957 shift
1958 done
1959 else
1960 SEARCH_PATH=("${@#/}")
1961 SEARCH_PATH=("${SEARCH_PATH[@]/#/${root}/}")
1962 fi
1963 else
1964 local dir sitedir
1965 for dir in "${root}"/usr/lib*; do
1966 if [[ -d "${dir}" && ! -L "${dir}" ]]; then
1967 for sitedir in "${dir}"/python*/site-packages; do
1968 if [[ -d "${sitedir}" ]]; then
1969 SEARCH_PATH+=("${sitedir}")
1970 fi 2937 fi
2938 else
2939 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2940 search_paths+=("${root}$(python_get_sitedir)/$1")
1971 done 2941 done
1972 fi 2942 fi
2943 shift
1973 done 2944 done
1974 for sitedir in "${root}"/usr/share/jython-*/Lib/site-packages; do 2945 else
1975 if [[ -d "${sitedir}" ]]; then 2946 # Deprecated part of python_mod_cleanup()
1976 SEARCH_PATH+=("${sitedir}") 2947 ewarn
1977 fi 2948 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
1978 done 2949 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
1979 fi 2950 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
2951 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
2952 ewarn
1980 2953
1981 for path in "${SEARCH_PATH[@]}"; do 2954 search_paths=("${@#/}")
1982 if [[ -d "${path}" ]]; then 2955 search_paths=("${search_paths[@]/#/${root}/}")
1983 find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0 | while read -rd ''; do
1984 if [[ "${REPLY}" == *[co] ]]; then
1985 py_file="${REPLY%[co]}"
1986 [[ -f "${py_file}" || (! -f "${py_file}c" && ! -f "${py_file}o") ]] && continue
1987 einfo "${_BLUE}<<< ${py_file}[co]${_NORMAL}"
1988 rm -f "${py_file}"[co]
1989 elif [[ "${REPLY}" == *\$py.class ]]; then
1990 py_file="${REPLY%\$py.class}.py"
1991 [[ -f "${py_file}" || ! -f "${py_file%.py}\$py.class" ]] && continue
1992 einfo "${_BLUE}<<< ${py_file%.py}\$py.class${_NORMAL}"
1993 rm -f "${py_file%.py}\$py.class"
1994 fi
1995 done
1996
1997 # Attempt to delete directories, which may be empty.
1998 find "${path}" -type d | sort -r | while read -r dir; do
1999 rmdir "${dir}" 2>/dev/null && einfo "${_CYAN}<<< ${dir}${_NORMAL}"
2000 done
2001 elif [[ "${path}" == *.py && ! -f "${path}" ]]; then
2002 if [[ (-f "${path}c" || -f "${path}o") ]]; then
2003 einfo "${_BLUE}<<< ${path}[co]${_NORMAL}"
2004 rm -f "${path}"[co]
2005 fi
2006 if [[ -f "${path%.py}\$py.class" ]]; then
2007 einfo "${_BLUE}<<< ${path%.py}\$py.class${_NORMAL}"
2008 rm -f "${path%.py}\$py.class"
2009 fi
2010 fi 2956 fi
2011 done 2957
2958 _python_clean_compiled_modules "${search_paths[@]}"
2012} 2959}
2013 2960
2014# ================================================================================================ 2961# ================================================================================================
2015# ===================================== DEPRECATED FUNCTIONS ===================================== 2962# ===================================== DEPRECATED FUNCTIONS =====================================
2016# ================================================================================================ 2963# ================================================================================================
2017
2018# @FUNCTION: python_version
2019# @DESCRIPTION:
2020# Run without arguments and it will export the version of python
2021# currently in use as $PYVER; sets PYVER/PYVER_MAJOR/PYVER_MINOR
2022python_version() {
2023 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
2024 eerror "Use PYTHON() and/or python_get_*() instead of ${FUNCNAME}()."
2025 die "${FUNCNAME}() cannot be used in this EAPI"
2026 fi
2027
2028 if [[ "${FUNCNAME[1]}" != "distutils_python_version" ]]; then
2029 einfo
2030 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01."
2031 einfo "Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables."
2032 einfo
2033 fi
2034
2035 [[ -n "${PYVER}" ]] && return 0
2036 local tmpstr
2037 python="${python:-${EPREFIX}/usr/bin/python}"
2038 tmpstr="$(EPYTHON= ${python} -V 2>&1 )"
2039 export PYVER_ALL="${tmpstr#Python }"
2040 export PYVER_MAJOR="${PYVER_ALL:0:1}"
2041 export PYVER_MINOR="${PYVER_ALL:2:1}"
2042 if [[ "${PYVER_ALL:3:1}" == "." ]]; then
2043 export PYVER_MICRO="${PYVER_ALL:4}"
2044 fi
2045 export PYVER="${PYVER_MAJOR}.${PYVER_MINOR}"
2046}
2047
2048# @FUNCTION: python_mod_exists
2049# @USAGE: <module>
2050# @DESCRIPTION:
2051# Run with the module name as an argument. It will check if a
2052# Python module is installed and loadable. It will return
2053# TRUE(0) if the module exists, and FALSE(1) if the module does
2054# not exist.
2055#
2056# Example:
2057# if python_mod_exists gtk; then
2058# echo "gtk support enabled"
2059# fi
2060python_mod_exists() {
2061 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
2062 eerror "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()."
2063 die "${FUNCNAME}() cannot be used in this EAPI"
2064 fi
2065
2066 einfo
2067 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01."
2068 einfo "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()."
2069 einfo
2070
2071 if [[ "$#" -ne 1 ]]; then
2072 die "${FUNCNAME}() requires 1 argument"
2073 fi
2074 "$(PYTHON ${PYTHON_ABI})" -c "import $1" &> /dev/null
2075}
2076
2077# @FUNCTION: python_tkinter_exists
2078# @DESCRIPTION:
2079# Run without arguments, checks if Python was compiled with Tkinter
2080# support. If not, prints an error message and dies.
2081python_tkinter_exists() {
2082 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
2083 eerror "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()."
2084 die "${FUNCNAME}() cannot be used in this EAPI"
2085 fi
2086
2087 if [[ "${FUNCNAME[1]}" != "distutils_python_tkinter" ]]; then
2088 einfo
2089 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01."
2090 einfo "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()."
2091 einfo
2092 fi
2093
2094 if ! "$(PYTHON ${PYTHON_ABI})" -c "from sys import version_info
2095if version_info[0] == 3:
2096 import tkinter
2097else:
2098 import Tkinter" &> /dev/null; then
2099 eerror "Python needs to be rebuilt with tkinter support enabled."
2100 eerror "Add the following line to '${EPREFIX}/etc/portage/package.use' and rebuild Python"
2101 eerror "dev-lang/python tk"
2102 die "Python installed without support for tkinter"
2103 fi
2104}
2105
2106# @FUNCTION: python_mod_compile
2107# @USAGE: <file> [more files ...]
2108# @DESCRIPTION:
2109# Given filenames, it will pre-compile the module's .pyc and .pyo.
2110# This function can be used only in pkg_postinst() phase.
2111#
2112# Example:
2113# python_mod_compile /usr/lib/python2.3/site-packages/pygoogle.py
2114#
2115python_mod_compile() {
2116 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
2117 eerror "Use python_mod_optimize() instead of ${FUNCNAME}()."
2118 die "${FUNCNAME}() cannot be used in this EAPI"
2119 fi
2120
2121 _python_initialize_prefix_variables
2122
2123 local f myroot myfiles=()
2124
2125 # Check if phase is pkg_postinst()
2126 [[ ${EBUILD_PHASE} != postinst ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2127
2128 # strip trailing slash
2129 myroot="${EROOT%/}"
2130
2131 # respect ROOT
2132 for f in "$@"; do
2133 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}")
2134 done
2135
2136 if ((${#myfiles[@]})); then
2137 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}"
2138 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null
2139 else
2140 ewarn "No files to compile!"
2141 fi
2142}

Legend:
Removed from v.1.93  
changed lines
  Added in v.1.120

  ViewVC Help
Powered by ViewVC 1.1.20